package view;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import javax.swing.JFileChooser;
import data.FNNXTreeNode;
import java.awt.event.WindowEvent;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StringReader;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.Enumeration;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import tools.VirtualConsole;
import java.util.Hashtable;
import java.util.NoSuchElementException;
import javax.swing.JFrame;
import javax.swing.filechooser.FileFilter;
import plugin.FNNXFunction;
import plugin.FNNXObject;
import scripting.FNNXLexer;
import scripting.FNNXParser;
import tools.FennixCore;
import tools.FileExtensionFilter;
import tools.MyClassLoader;
import tools.MyObjectInputStream;
import tools.scripting.AbstractVisualCommand;
import tools.scripting.VisualAssign;
import tools.scripting.VisualCall;
import tools.scripting.VisualMain;
import tools.scripting.VisualNew;

/*
 * MainWindow.java
 *
 * Backpropagation with momentum no flat spot elimination
 * Backprop speed: 20 times slower than JavaSNNS, trying to improve
 * Backprop speed: 10 times slower than JavaSNNS
 * CalcStatistics implemented (mean, minimum, maximum, range)
 * Percent of patterns learnt implemented
 * Implementing new threads for the learning algorithms
 * Error ploting parallelized
 * Trying to improve performance.   Changing data structure for patterns, OK
 *                                  Using exception for stop loops instead of hasNext(), NO
 * Implementing new data structure for the network elements, OK
 * Fixing bug in visualization of learnt patterns
 * Drawing axes in error graph, OK
 * Limit in size of error variable, OK
 * Adding maximum pattern learnt indicators 
 * Deleting menu panel
 * Creating resample patterns button
 * Variable range in initialization
 * Implememtation of hyperbolic tangent activation function
 * Buttons for custom activation function
 * Identifier is no more used
 * Correlation calculation implemented
 * Implementing n-folds cross validation
 * Ploting validation error
 * Implementing input pruning
 * Implementing functions in order to ignoring points
 * Implementing continuos relevance
 * Implementing network ensemble for cross-validation - not used anymore
 * Implementing network ensemble
 * Implementing input profile plot
 * Implementing GNG
 * Modifying GNG
 * Implementing GBS
 * Deleting error plot from main window (problems with netbeans and ...)
 * Creating the "experiment" object
 * Implementing file list screen
 * Implementing networks list screen
 * -----------------------------------------------------------------------------
 * Creation of FENIX
 * Creation of AbstractAlgorithm
 * Creation of Heap
 * Description of commands in a tree structure
 * -----------------------------------------------------------------------------
 * FENIX becomes FENNIX
 * Editing experiment
 * Change in VirtualConsole... Thread no more needed (100% CPU OK)
 * Implementing only one heap of variables (hashtable)
 * Changing Experiment by Script
 * Adding plot to Script
 * Creating plugins
 * Creating FNNXObject
 * Creating FNNXFunction
 * Creating FennixCore
 * Creating lexer, parser and interpreter
 * Changing Script by Interpreter
 * Adding save to functions
 * Created on 1. mai 2006, 10:32
 */

/**
 *
 * @author  hector
 */
public class MainWindow extends javax.swing.JFrame {
    
    /** Creates new form MainWindow */
    public MainWindow() {
        initComponents();
        initCreatedComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPopupMenuConsole = new javax.swing.JPopupMenu();
        jMenuItemClearConsole = new javax.swing.JMenuItem();
        jPopupMenuExperiment = new javax.swing.JPopupMenu();
        jMenuItemDeleteNode = new javax.swing.JMenuItem();
        jMenuItemDeleteAllNodes = new javax.swing.JMenuItem();
        jMenuItemEditNode = new javax.swing.JMenuItem();
        jDialogNewObject = new javax.swing.JDialog();
        jDialogNewObject.setSize(200, 400);
        jScrollPane9 = new javax.swing.JScrollPane();
        jListNewObject = new javax.swing.JList();
        jButtonCancelNewObject = new javax.swing.JButton();
        jDialogCallFunction = new javax.swing.JDialog();
        jDialogCallFunction.setSize(200, 400);
        jScrollPane10 = new javax.swing.JScrollPane();
        jListCallFunction = new javax.swing.JList();
        jButtonCancelCallFunction = new javax.swing.JButton();
        jDialogVisualAssign = new javax.swing.JDialog();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldVisualAssign = new javax.swing.JTextField();
        jButtonOKVisualAssign = new javax.swing.JButton();
        buttonGroupAddAppend = new javax.swing.ButtonGroup();
        jDialogAbout = new javax.swing.JDialog();
        jDialogAbout.setSize(300, 200);
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jPanelExperiment = new javax.swing.JPanel();
        jTabbedPaneExperiment = new javax.swing.JTabbedPane();
        jPanelTextScript = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextAreaTextScript = new javax.swing.JTextArea();
        jPanelNodesControl = new javax.swing.JPanel();
        jButtonRunExperiment = new javax.swing.JButton();
        jButtonPauseResumeExperiment = new javax.swing.JButton();
        jButtonEndExperiment = new javax.swing.JButton();
        jButtonDeleteNodes = new javax.swing.JButton();
        jButtonSaveExperiment = new javax.swing.JButton();
        jButtonLoadExperiment = new javax.swing.JButton();
        jPanelGraphicScript = new javax.swing.JPanel();
        jPanelCreation = new javax.swing.JPanel();
        jButtonVar = new javax.swing.JButton();
        jButtonNew = new javax.swing.JButton();
        jButtonCall = new javax.swing.JButton();
        jButtonTranslate = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jRadioButtonInsert = new javax.swing.JRadioButton();
        jRadioButtonAppend = new javax.swing.JRadioButton();
        jButtonSaveTree = new javax.swing.JButton();
        jButtonLoadTree = new javax.swing.JButton();
        jScrollPaneExperiment = new javax.swing.JScrollPane();
        ////algorithmList = new javax.swing.tree.DefaultMutableTreeNode(Names.configuration.begin.toString());
        //algorithmList = new javax.swing.tree.DefaultMutableTreeNode(Names.command.begin.toString());
        algorithmList = new javax.swing.tree.DefaultMutableTreeNode(new VisualMain());
        algorithmListModel = new DefaultTreeModel(algorithmList);
        jTreeNodes = jTreeNodes = new javax.swing.JTree(algorithmListModel);
        jTreeNodes.setShowsRootHandles(true);
        jTreeNodes.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        jPanelControl = new javax.swing.JPanel();
        jScrollPaneConsole = new javax.swing.JScrollPane();
        jTextAreaConsole = new javax.swing.JTextArea();
        jPanelCommands = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldCommands = new javax.swing.JTextField();
        jTextFieldCommands.getCaret().setBlinkRate(100);
        jMenuBarFennix = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuItemSaveWorkspace = new javax.swing.JMenuItem();
        jMenuItemLoadWorkspace = new javax.swing.JMenuItem();
        jMenuItemShowWorkspace = new javax.swing.JMenuItem();
        jMenuHelp = new javax.swing.JMenu();
        jMenuItemAbout = new javax.swing.JMenuItem();

        jMenuItemClearConsole.setText("Clear console");
        jMenuItemClearConsole.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearConsoleActionPerformed(evt);
            }
        });
        jPopupMenuConsole.add(jMenuItemClearConsole);

        jMenuItemDeleteNode.setText("Delete this node");
        jMenuItemDeleteNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDeleteNodeActionPerformed(evt);
            }
        });
        jPopupMenuExperiment.add(jMenuItemDeleteNode);

        jMenuItemDeleteAllNodes.setText("Delete all nodes");
        jPopupMenuExperiment.add(jMenuItemDeleteAllNodes);

        jMenuItemEditNode.setText("EditNode");
        jMenuItemEditNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemEditNodeActionPerformed(evt);
            }
        });
        jPopupMenuExperiment.add(jMenuItemEditNode);

        jDialogNewObject.setTitle("New Object");
        jDialogNewObject.getContentPane().setLayout(new java.awt.BorderLayout(5, 5));

        jListNewObject.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListNewObjectMouseClicked(evt);
            }
        });
        jScrollPane9.setViewportView(jListNewObject);

        jDialogNewObject.getContentPane().add(jScrollPane9, java.awt.BorderLayout.CENTER);

        jButtonCancelNewObject.setText("Cancel");
        jButtonCancelNewObject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelNewObjectActionPerformed(evt);
            }
        });
        jDialogNewObject.getContentPane().add(jButtonCancelNewObject, java.awt.BorderLayout.PAGE_END);

        jDialogCallFunction.setTitle("New Object");
        jDialogCallFunction.getContentPane().setLayout(new java.awt.BorderLayout(5, 5));

        jListCallFunction.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListCallFunctionMouseClicked(evt);
            }
        });
        jScrollPane10.setViewportView(jListCallFunction);

        jDialogCallFunction.getContentPane().add(jScrollPane10, java.awt.BorderLayout.CENTER);

        jButtonCancelCallFunction.setText("Cancel");
        jButtonCancelCallFunction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelCallFunctionActionPerformed(evt);
            }
        });
        jDialogCallFunction.getContentPane().add(jButtonCancelCallFunction, java.awt.BorderLayout.PAGE_END);

        jDialogVisualAssign.setTitle("Create a new variable");
        jDialogVisualAssign.setSize(300, 150);
        jDialogVisualAssign.getContentPane().setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Variable name:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jDialogVisualAssign.getContentPane().add(jLabel2, gridBagConstraints);

        jTextFieldVisualAssign.setPreferredSize(new java.awt.Dimension(80, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jDialogVisualAssign.getContentPane().add(jTextFieldVisualAssign, gridBagConstraints);

        jButtonOKVisualAssign.setText("OK");
        jButtonOKVisualAssign.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKVisualAssignActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jDialogVisualAssign.getContentPane().add(jButtonOKVisualAssign, gridBagConstraints);

        jDialogAbout.setTitle("About");

        jTextPane1.setText("Dear user... FENNIX has changed... tired of dealing with \"no-geek\" users... it has a new interface...but do not worry, for all those \"no-geeks\" a particularly simple window has been developed... sorry for them... but this binary world is changing... \"to be a geek is the only choise\" ..stay tune... we are watching you. Written by a \"no-geek\".");
        jScrollPane1.setViewportView(jTextPane1);

        org.jdesktop.layout.GroupLayout jDialogAboutLayout = new org.jdesktop.layout.GroupLayout(jDialogAbout.getContentPane());
        jDialogAbout.getContentPane().setLayout(jDialogAboutLayout);
        jDialogAboutLayout.setHorizontalGroup(
            jDialogAboutLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jDialogAboutLayout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 321, Short.MAX_VALUE)
                .addContainerGap())
        );
        jDialogAboutLayout.setVerticalGroup(
            jDialogAboutLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jDialogAboutLayout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
                .addContainerGap())
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("FENNIX_013");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("mainFrame"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                closing(evt);
            }
        });
        getContentPane().setLayout(new java.awt.GridLayout(1, 2));

        jPanelExperiment.setBorder(javax.swing.BorderFactory.createTitledBorder("Experiment"));
        jPanelExperiment.setLayout(new java.awt.BorderLayout());

        jPanelTextScript.setLayout(new java.awt.BorderLayout());

        jTextAreaTextScript.setColumns(20);
        jTextAreaTextScript.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
        jTextAreaTextScript.setRows(5);
        jScrollPane2.setViewportView(jTextAreaTextScript);

        jPanelTextScript.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanelNodesControl.setLayout(new java.awt.GridLayout(3, 2, 2, 2));

        jButtonRunExperiment.setText("Run Experiment");
        jButtonRunExperiment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRunExperimentActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonRunExperiment);

        jButtonPauseResumeExperiment.setText("Pause Experiment");
        jButtonPauseResumeExperiment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPauseResumeExperimentActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonPauseResumeExperiment);

        jButtonEndExperiment.setText("End Experiment");
        jButtonEndExperiment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEndExperimentActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonEndExperiment);

        jButtonDeleteNodes.setText("Delete All");
        jButtonDeleteNodes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteNodesActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonDeleteNodes);

        jButtonSaveExperiment.setText("Save Experiment");
        jButtonSaveExperiment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveExperimentActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonSaveExperiment);

        jButtonLoadExperiment.setText("Load Experiment");
        jButtonLoadExperiment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadExperimentActionPerformed(evt);
            }
        });
        jPanelNodesControl.add(jButtonLoadExperiment);

        jPanelTextScript.add(jPanelNodesControl, java.awt.BorderLayout.PAGE_END);

        jTabbedPaneExperiment.addTab("Text Script", jPanelTextScript);

        jPanelGraphicScript.setLayout(new javax.swing.BoxLayout(jPanelGraphicScript, javax.swing.BoxLayout.X_AXIS));

        jPanelCreation.setLayout(new java.awt.GridLayout(10, 1, 5, 5));

        jButtonVar.setText("Var");
        jButtonVar.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonVar.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonVar.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonVar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVarActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonVar);

        jButtonNew.setText("New");
        jButtonNew.setEnabled(false);
        jButtonNew.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonNew.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonNew.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNewActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonNew);

        jButtonCall.setText("Call");
        jButtonCall.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonCall.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonCall.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonCall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCallActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonCall);

        jButtonTranslate.setBackground(new java.awt.Color(0, 153, 153));
        jButtonTranslate.setFont(new java.awt.Font("Dialog", 1, 18));
        jButtonTranslate.setText("<-");
        jButtonTranslate.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonTranslate.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonTranslate.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonTranslate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTranslateActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonTranslate);
        jPanelCreation.add(jSeparator1);

        buttonGroupAddAppend.add(jRadioButtonInsert);
        jRadioButtonInsert.setText("Insert");
        jRadioButtonInsert.setMaximumSize(new java.awt.Dimension(50, 25));
        jRadioButtonInsert.setMinimumSize(new java.awt.Dimension(20, 25));
        jRadioButtonInsert.setPreferredSize(new java.awt.Dimension(20, 25));
        jRadioButtonInsert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonInsertActionPerformed(evt);
            }
        });
        jPanelCreation.add(jRadioButtonInsert);

        buttonGroupAddAppend.add(jRadioButtonAppend);
        jRadioButtonAppend.setSelected(true);
        jRadioButtonAppend.setText("Append");
        jRadioButtonAppend.setMaximumSize(new java.awt.Dimension(50, 25));
        jRadioButtonAppend.setMinimumSize(new java.awt.Dimension(20, 25));
        jRadioButtonAppend.setPreferredSize(new java.awt.Dimension(20, 25));
        jRadioButtonAppend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonAppendActionPerformed(evt);
            }
        });
        jPanelCreation.add(jRadioButtonAppend);

        jButtonSaveTree.setText("Save");
        jButtonSaveTree.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonSaveTree.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonSaveTree.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonSaveTree.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveTreeActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonSaveTree);

        jButtonLoadTree.setText("Load");
        jButtonLoadTree.setMaximumSize(new java.awt.Dimension(50, 25));
        jButtonLoadTree.setMinimumSize(new java.awt.Dimension(20, 25));
        jButtonLoadTree.setPreferredSize(new java.awt.Dimension(20, 25));
        jButtonLoadTree.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadTreeActionPerformed(evt);
            }
        });
        jPanelCreation.add(jButtonLoadTree);

        jPanelGraphicScript.add(jPanelCreation);

        jScrollPaneExperiment.setMinimumSize(new java.awt.Dimension(50, 22));
        jScrollPaneExperiment.setPreferredSize(new java.awt.Dimension(150, 363));

        jTreeNodes.setComponentPopupMenu(jPopupMenuExperiment);
        jTreeNodes.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTreeNodesValueChanged(evt);
            }
        });
        jScrollPaneExperiment.setViewportView(jTreeNodes);

        jPanelGraphicScript.add(jScrollPaneExperiment);

        jTabbedPaneExperiment.addTab("Graphic Script", jPanelGraphicScript);

        jPanelExperiment.add(jTabbedPaneExperiment, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanelExperiment);

        jTextAreaConsole.setBackground(new java.awt.Color(0, 0, 0));
        jTextAreaConsole.setColumns(20);
        jTextAreaConsole.setEditable(false);
        jTextAreaConsole.setFont(new java.awt.Font("Monospaced", 0, 12));
        jTextAreaConsole.setForeground(new java.awt.Color(255, 255, 255));
        jTextAreaConsole.setRows(4);
        jTextAreaConsole.setTabSize(4);
        jTextAreaConsole.setCaretColor(new java.awt.Color(255, 255, 255));
        jTextAreaConsole.setComponentPopupMenu(jPopupMenuConsole);
        jScrollPaneConsole.setViewportView(jTextAreaConsole);

        jPanelCommands.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelCommands.setLayout(new javax.swing.BoxLayout(jPanelCommands, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setBackground(new java.awt.Color(255, 255, 153));
        jLabel1.setText(">");
        jLabel1.setOpaque(true);
        jPanelCommands.add(jLabel1);

        jTextFieldCommands.setBackground(new java.awt.Color(255, 255, 153));
        jTextFieldCommands.setBorder(null);
        jTextFieldCommands.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldCommandsActionPerformed(evt);
            }
        });
        jPanelCommands.add(jTextFieldCommands);

        org.jdesktop.layout.GroupLayout jPanelControlLayout = new org.jdesktop.layout.GroupLayout(jPanelControl);
        jPanelControl.setLayout(jPanelControlLayout);
        jPanelControlLayout.setHorizontalGroup(
            jPanelControlLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanelControlLayout.createSequentialGroup()
                .add(jPanelControlLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jScrollPaneConsole, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                    .add(jPanelCommands, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanelControlLayout.setVerticalGroup(
            jPanelControlLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanelControlLayout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPaneConsole, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 483, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanelCommands, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        getContentPane().add(jPanelControl);

        jMenuFile.setText("File");

        jMenuItemSaveWorkspace.setText("SaveWorkspace");
        jMenuItemSaveWorkspace.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveWorkspaceActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSaveWorkspace);

        jMenuItemLoadWorkspace.setText("LoadWorkspace");
        jMenuItemLoadWorkspace.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLoadWorkspaceActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemLoadWorkspace);

        jMenuItemShowWorkspace.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemShowWorkspace.setText("ShowWorkspace");
        jMenuItemShowWorkspace.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemShowWorkspaceActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemShowWorkspace);

        jMenuBarFennix.add(jMenuFile);

        jMenuHelp.setText("Help");

        jMenuItemAbout.setText("About");
        jMenuItemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAboutActionPerformed(evt);
            }
        });
        jMenuHelp.add(jMenuItemAbout);

        jMenuBarFennix.add(jMenuHelp);

        setJMenuBar(jMenuBarFennix);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    /**/
    private void jButtonPauseResumeExperimentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPauseResumeExperimentActionPerformed
        if (jButtonPauseResumeExperiment.getText().compareTo("Pause Experiment") == 0) {
            if (fennix.getMonitor().isRunning()) {
                jButtonPauseResumeExperiment.setText("Resume Experiment");
                fennix.getMonitor().pause();
            }
        }
        else {
            if (fennix.getMonitor().isRunning()) {
                jButtonPauseResumeExperiment.setText("Pause Experiment");
                fennix.getMonitor().resume();
            }
        }
}//GEN-LAST:event_jButtonPauseResumeExperimentActionPerformed

    private void jButtonRunExperimentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRunExperimentActionPerformed
        if (fennix.getMonitor().isRunning()) {
            jTextAreaConsole.append("An Experiment is already running.\n");
            return;
        }
        
        fennix.runScriptReader(new BufferedReader(new StringReader(jTextAreaTextScript.getText())), true);
        
    }//GEN-LAST:event_jButtonRunExperimentActionPerformed
    
    private void jButtonEndExperimentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEndExperimentActionPerformed
        fennix.getMonitor().abort();
}//GEN-LAST:event_jButtonEndExperimentActionPerformed

    private void jButtonLoadExperimentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadExperimentActionPerformed
        FileFilter filter = new FileExtensionFilter("Script files (.fxs)", "fxs");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showOpenDialog(null);
        
        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                BufferedReader reader = new BufferedReader(new FileReader(fileSelection.getSelectedFile().getPath()));
                jTextAreaTextScript.selectAll();
                jTextAreaTextScript.replaceSelection("");
                while (reader.ready()) {
                    jTextAreaTextScript.append(reader.readLine());
                    jTextAreaTextScript.append("\n");
                }
                reader.close();
            }
            catch (FileNotFoundException fe) {
            }
            catch (IOException ie) {
            }
        }
    }//GEN-LAST:event_jButtonLoadExperimentActionPerformed

    private void jButtonDeleteNodesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteNodesActionPerformed
        jTextAreaTextScript.selectAll();
        jTextAreaTextScript.replaceSelection("");
}//GEN-LAST:event_jButtonDeleteNodesActionPerformed

    private void jButtonSaveExperimentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveExperimentActionPerformed
        FileFilter filter = new FileExtensionFilter("Script files (.fxs)", "fxs");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showSaveDialog(null);
        
        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                BufferedWriter writer = new BufferedWriter(new FileWriter(fileSelection.getSelectedFile().getPath()));
                writer.write(jTextAreaTextScript.getText());
                writer.close();
            }
            catch (FileNotFoundException ex) {
            }
            catch (IOException ie) {
            }
        }
    }//GEN-LAST:event_jButtonSaveExperimentActionPerformed

    private void jMenuItemClearConsoleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearConsoleActionPerformed
        jTextAreaConsole.setText("");
}//GEN-LAST:event_jMenuItemClearConsoleActionPerformed

    private void jMenuItemDeleteNodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDeleteNodeActionPerformed
        selectedNode = null;
        TreePath parentPath = jTreeNodes.getSelectionPath();

        if (parentPath != null) {
            selectedNode = (DefaultMutableTreeNode)(parentPath.getLastPathComponent());
            
            if (selectedNode.getUserObject() instanceof VisualMain) {
                return;
            }
            
            selectedNode.removeFromParent();
            algorithmListModel.reload();
            jTreeNodes.updateUI();
            
        }
}//GEN-LAST:event_jMenuItemDeleteNodeActionPerformed

    private void jButtonCancelNewObjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelNewObjectActionPerformed
        jDialogNewObject.setVisible(false);
}//GEN-LAST:event_jButtonCancelNewObjectActionPerformed

    private void jListNewObjectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListNewObjectMouseClicked
        if (evt.getClickCount() > 1) {
            jDialogNewObject.setVisible(false);

            if (jListNewObject.isSelectionEmpty()) {
                return;
            }

            FNNXObject plugin;
            String[] parameterNames;
            String[] parameters;
            try {
                Class toolClass = (Class)plugins.get((String)jListNewObject.getSelectedValue());
                if (toolClass.getInterfaces()[0] == FNNXObject.class) {
                    Constructor constructor = toolClass.getConstructor(new Class[] {JFrame.class});
                    plugin = (FNNXObject)constructor.newInstance(new Object[] {this});
                    if (plugin.configure()) {
                        parameterNames = plugin.getParameterNames();
                        parameters = plugin.getParameterText();

                        DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(new VisualNew(plugin.toString()));
                        DefaultMutableTreeNode newChild;
                        for (int i = 0; i < parameterNames.length; i++) {
                            if (parameters[i] != null) {
                                if (parameters[i].compareTo("") != 0) {
                                    newChild = new DefaultMutableTreeNode(new VisualAssign(parameterNames[i]));
                                    newChild.add(new DefaultMutableTreeNode(parameters[i]));
                                    newNode.add(newChild);
                                }
                            }
                        }
                        putNode(newNode);
                    }
                }
                else {
                    System.out.println("Error. This command is not a valid plugin.");
                }
            }
            catch (InstantiationException ie) {
                System.out.println("Error. Impossible to instantiate plugin.");
            }
            catch (IllegalAccessException ae) {
                System.out.println("Error. Impossible to access plugin.");
            }
            catch (NoSuchMethodException me) {
                System.out.println("Error. Impossible to find constructor.");
            }
            catch (InvocationTargetException te) {
                System.out.println("Error. Impossible to initialize plugin.");
            }

        }

    }//GEN-LAST:event_jListNewObjectMouseClicked

    private void jListCallFunctionMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListCallFunctionMouseClicked
        if (evt.getClickCount() > 1) {
            jDialogCallFunction.setVisible(false);

            if (jListCallFunction.isSelectionEmpty()) {
                return;
            }

            FNNXFunction plugin;
            String[] parameterNames;
            String[] parameters;
            try {
                Class toolClass = (Class)plugins.get((String)jListCallFunction.getSelectedValue());
                if (toolClass.getInterfaces()[0] == FNNXObject.class) {
                    Constructor constructor = toolClass.getConstructor(new Class[] {JFrame.class});
                    plugin = (FNNXFunction)constructor.newInstance(new Object[] {this});
                    if (plugin.configure()) {
                        parameterNames = plugin.getParameterNames();
                        parameters = plugin.getParameterText();

                        DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(new VisualCall(plugin.toString()));
                        DefaultMutableTreeNode newChild;
                        for (int i = 0; i < parameterNames.length; i++) {
                            if (parameters[i] != null) {
                                if (parameters[i].compareTo("") != 0) {
                                    newChild = new DefaultMutableTreeNode(new VisualAssign(parameterNames[i]));
                                    newChild.add(new DefaultMutableTreeNode(parameters[i]));
                                    newNode.add(newChild);
                                }
                            }
                        }
                        putNode(newNode);
                    }
                }
                else {
                    System.out.println("Error. This command is not a valid plugin.");
                }
            }
            catch (InstantiationException ie) {
                System.out.println("Error. Impossible to instantiate plugin.");
            }
            catch (IllegalAccessException ae) {
                System.out.println("Error. Impossible to access plugin.");
            }
            catch (NoSuchMethodException me) {
                System.out.println("Error. Impossible to find constructor.");
            }
            catch (InvocationTargetException te) {
                System.out.println("Error. Impossible to initialize plugin.");
            }

        }
}//GEN-LAST:event_jListCallFunctionMouseClicked

    private void jButtonCancelCallFunctionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelCallFunctionActionPerformed
        jDialogCallFunction.setVisible(false);
}//GEN-LAST:event_jButtonCancelCallFunctionActionPerformed

    private void closing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closing
        fennix.quit();
        dispose();

        System.exit(0);
    }//GEN-LAST:event_closing

    private void jTextFieldCommandsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldCommandsActionPerformed
        String temp = jTextFieldCommands.getText().trim();
        System.out.println(temp);
        fennix.decode(temp, true);
        jTextFieldCommands.setText("");

        if (!fennix.isRunning()) {
            processEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
        }
}//GEN-LAST:event_jTextFieldCommandsActionPerformed

    private void jButtonVarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVarActionPerformed
        jDialogVisualAssign.setVisible(true);
    }//GEN-LAST:event_jButtonVarActionPerformed

    private void jButtonOKVisualAssignActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKVisualAssignActionPerformed
        jDialogVisualAssign.setVisible(false);

        if (jTextFieldVisualAssign.getText() == null) {
            return;
        }

        if (editing) {
            selectedNode.setUserObject(new VisualAssign(jTextFieldVisualAssign.getText()));
            editing = false;
            jTreeNodes.updateUI();
        }
        else {
            putNode(new DefaultMutableTreeNode(new VisualAssign(jTextFieldVisualAssign.getText())));
        }
    }//GEN-LAST:event_jButtonOKVisualAssignActionPerformed

    private void jTreeNodesValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTreeNodesValueChanged
        enableCommands();
    }//GEN-LAST:event_jTreeNodesValueChanged

    private void enableCommands() {
        selectedNode = null;
        TreePath parentPath = jTreeNodes.getSelectionPath();

        if (parentPath == null) {
            jButtonVar.setEnabled(true);
            jButtonNew.setEnabled(false);
            jButtonCall.setEnabled(true);
            return;
        }

        selectedNode = (DefaultMutableTreeNode)(parentPath.getLastPathComponent());

        Object current = selectedNode.getUserObject();

        if (jRadioButtonAppend.isSelected()) {
            jButtonVar.setEnabled(false);
            jButtonNew.setEnabled(false);
            jButtonCall.setEnabled(false);

            if (current instanceof VisualMain) {
                jButtonVar.setEnabled(true);
                jButtonCall.setEnabled(true);
            }
            else if (current instanceof VisualAssign) {
                if (selectedNode.getChildCount() < 1) {
                    jButtonNew.setEnabled(true);
                    jButtonCall.setEnabled(true);
                }
            }
        }
        else {
            jButtonVar.setEnabled(true);
            jButtonNew.setEnabled(true);
            jButtonCall.setEnabled(true);

            if (current instanceof VisualMain) {
                jButtonVar.setEnabled(false);
                jButtonNew.setEnabled(false);
                jButtonCall.setEnabled(false);
            }
            else if (current instanceof VisualAssign) {
                jButtonNew.setEnabled(false);
            }
        }
    }

    private void jButtonNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewActionPerformed
        jDialogNewObject.setVisible(true);
    }//GEN-LAST:event_jButtonNewActionPerformed

    private void jButtonCallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCallActionPerformed
        jDialogCallFunction.setVisible(true);
    }//GEN-LAST:event_jButtonCallActionPerformed

    private void jButtonTranslateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTranslateActionPerformed
        jTextAreaTextScript.selectAll();
        jTextAreaTextScript.replaceSelection("");
        translate(algorithmList, "");
    }//GEN-LAST:event_jButtonTranslateActionPerformed

    private void jRadioButtonInsertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonInsertActionPerformed
        enableCommands();
}//GEN-LAST:event_jRadioButtonInsertActionPerformed

    private void jRadioButtonAppendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonAppendActionPerformed
        enableCommands();
    }//GEN-LAST:event_jRadioButtonAppendActionPerformed

    private void jMenuItemSaveWorkspaceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveWorkspaceActionPerformed

        FileFilter filter = new FileExtensionFilter("Workspace files (.fxw)", "fxw");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showSaveDialog(null);

        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(fileSelection.getSelectedFile().getPath()));
                out.writeObject(objects);
                out.close();
            }
            catch (IOException e) {
                System.out.println("Error saving variables");
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_jMenuItemSaveWorkspaceActionPerformed

    private void jMenuItemLoadWorkspaceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLoadWorkspaceActionPerformed

        FileFilter filter = new FileExtensionFilter("Workspace files (.fxw)", "fxw");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showOpenDialog(null);

        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                MyObjectInputStream input = new MyObjectInputStream(new FileInputStream(fileSelection.getSelectedFile().getPath()), new MyClassLoader(plugins));
                Hashtable<String, Object> temp;
                temp = (Hashtable<String, Object>)input.readObject();
                input.close();

                objects.putAll(temp);

            }
            catch(IOException ex) {
                System.out.println("File not found");
//                ex.printStackTrace();
            }
            catch(ClassNotFoundException ex) {
                System.out.println("File does not contain a valid variable list");
//                ex.printStackTrace();
            }
        }
    }//GEN-LAST:event_jMenuItemLoadWorkspaceActionPerformed

    private void jMenuItemShowWorkspaceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemShowWorkspaceActionPerformed
        workspace.setVisible(true);
    }//GEN-LAST:event_jMenuItemShowWorkspaceActionPerformed

    private void jButtonSaveTreeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveTreeActionPerformed
        FileFilter filter = new FileExtensionFilter("Visual Tree files (.fxt)", "fxt");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showSaveDialog(null);

        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                XMLEncoder encoder = new XMLEncoder(new BufferedOutputStream(new FileOutputStream(fileSelection.getSelectedFile().getPath())));
                encoder.writeObject((DefaultTreeModel)jTreeNodes.getModel());
                encoder.close();
            }
            catch (FileNotFoundException ex) {
            }
        }
    }//GEN-LAST:event_jButtonSaveTreeActionPerformed

    private void jButtonLoadTreeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadTreeActionPerformed
        FileFilter filter = new FileExtensionFilter("Visual Tree files (.fxt)", "fxt");
        JFileChooser fileSelection = new JFileChooser();
        fileSelection.addChoosableFileFilter(filter);
        fileSelection.setCurrentDirectory(filePath);
        int r = fileSelection.showOpenDialog(null);

        if (r == JFileChooser.APPROVE_OPTION) {
            filePath = fileSelection.getCurrentDirectory();
            try {
                XMLDecoder decoder = new XMLDecoder(new BufferedInputStream(new FileInputStream(fileSelection.getSelectedFile().getPath())));
                algorithmList.removeAllChildren();
                DefaultTreeModel treeModel = (DefaultTreeModel) decoder.readObject();
                decoder.close();

                jTreeNodes = new javax.swing.JTree(treeModel);
                jTreeNodes.setShowsRootHandles(true);
                jScrollPaneExperiment.setViewportView(jTreeNodes);

                algorithmList = (DefaultMutableTreeNode)treeModel.getRoot();
            }
            catch (FileNotFoundException e) {
            }
        }
    }//GEN-LAST:event_jButtonLoadTreeActionPerformed

    private void jMenuItemEditNodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemEditNodeActionPerformed
        selectedNode = null;
        TreePath parentPath = jTreeNodes.getSelectionPath();

        if (parentPath != null) {
            editing = true;
            selectedNode = (DefaultMutableTreeNode)(parentPath.getLastPathComponent());

            if (selectedNode.getUserObject() instanceof VisualMain) {
                return;
            }

            if (selectedNode.getUserObject() instanceof VisualAssign) {
                jDialogVisualAssign.setVisible(true);
            }

            if ((selectedNode.getUserObject() instanceof VisualNew) || (selectedNode.getUserObject() instanceof VisualCall)) {

                FNNXObject plugin;
                String[] parameterNames;
                String[] parameters;
                DefaultMutableTreeNode currentNode;
                AbstractVisualCommand current = (AbstractVisualCommand)selectedNode.getUserObject();

                try {
                    Class toolClass = (Class)plugins.get(current.getTargetName());
                    if (toolClass.getInterfaces()[0] == FNNXObject.class) {
                        Constructor constructor = toolClass.getConstructor(new Class[] {JFrame.class});
                        plugin = (FNNXObject)constructor.newInstance(new Object[] {this});

                        Enumeration enu = selectedNode.children();
                        String[] fields = new String[plugin.getParameterNames().length];
                        String name;
                        int i;

                        while (enu.hasMoreElements()) {
                            currentNode = (DefaultMutableTreeNode)enu.nextElement();
                            name = currentNode.getUserObject().toString();
                            name = name.substring(0, name.lastIndexOf('=')).trim();
                            System.out.println(name);
                            i = plugin.getParameterIndex(name);
                            if (i >= 0) {
                                fields[i] = currentNode.getFirstLeaf().getUserObject().toString();
                                System.out.println(fields[i]);
                            }
                        }

                        plugin.setParameterText(fields);

                        if (plugin.configure()) {
                            parameterNames = plugin.getParameterNames();
                            parameters = plugin.getParameterText();

                            DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(new VisualNew(plugin.toString()));
                            DefaultMutableTreeNode newChild;
                            for (i = 0; i < parameterNames.length; i++) {
                                if (parameters[i] != null) {
                                    if (parameters[i].compareTo("") != 0) {
                                        newChild = new DefaultMutableTreeNode(new VisualAssign(parameterNames[i]));
                                        newChild.add(new DefaultMutableTreeNode(parameters[i]));
                                        newNode.add(newChild);
                                    }
                                }
                            }
                            putNode(newNode);
                        }
                    }
                    else {
                        System.out.println("Error. This command is not a valid plugin.");
                    }
                }
                catch (InstantiationException ie) {
                    System.out.println("Error. Impossible to instantiate plugin.");
                }
                catch (IllegalAccessException ae) {
                    System.out.println("Error. Impossible to access plugin.");
                }
                catch (NoSuchMethodException me) {
                    System.out.println("Error. Impossible to find constructor.");
                }
                catch (InvocationTargetException te) {
                    System.out.println("Error. Impossible to initialize plugin.");
                }

            }

        }
    }//GEN-LAST:event_jMenuItemEditNodeActionPerformed

    private void jMenuItemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAboutActionPerformed
        jDialogAbout.setVisible(true);
    }//GEN-LAST:event_jMenuItemAboutActionPerformed

    private void translate(DefaultMutableTreeNode tree, String tab) {

        int i;
        Object object = tree.getUserObject();

        try {
            if (object instanceof VisualMain) {
                for (i = 0; i < tree.getChildCount(); i++) {
                    translate((DefaultMutableTreeNode)tree.getChildAt(i), tab);
                }
            }
            else if (object instanceof VisualAssign) {
                jTextAreaTextScript.append(tab + object.toString());

                translate((DefaultMutableTreeNode)tree.getFirstChild(), tab);
            }
            else if ((object instanceof VisualNew) || (object instanceof VisualCall)) {
                jTextAreaTextScript.append(tab + object.toString());
                if (tree.isLeaf()) {
                    jTextAreaTextScript.append("\n");
                }
                else {
                    jTextAreaTextScript.append(" {\n");
                    for (i = 0; i < tree.getChildCount(); i++) {
                        translate((DefaultMutableTreeNode)tree.getChildAt(i), (tab+"\t"));
                    }
                    jTextAreaTextScript.append(tab + "}\n");
                }
            }
            else {
                jTextAreaTextScript.append(tab + object.toString() + "\n");
            }
        }
        catch (NoSuchElementException ne) {
        }
        
    }

    private void putNode(DefaultMutableTreeNode n) {
        if (editing) {
            editing = false;
            selectedNode.removeAllChildren();
            selectedNode.setUserObject(n.getUserObject());
            while (n.getChildCount() > 0) {
                selectedNode.add((DefaultMutableTreeNode)n.getFirstChild());
            }
        }
        else {
            if (selectedNode == null) {
                selectedNode = algorithmList;
            }

            if (jRadioButtonAppend.isSelected()) {
                selectedNode.add(n);
            }
            else {
                DefaultMutableTreeNode parent = (DefaultMutableTreeNode)selectedNode.getParent();
                parent.insert(n, parent.getIndex(selectedNode));
            }
        }

        jTreeNodes.updateUI();
        enableCommands();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        fennix = new FennixCore();

        if (args.length == 0) {
            java.awt.EventQueue.invokeLater(new Runnable() {
                public void run() {
                    new MainWindow().setVisible(true);
                }
            });
        }
        else if ((args[0].compareTo("-c") == 0) || (args[0].compareTo("--console") == 0)) {
            fennix.loadInitTools();
            fennix.runConsole(System.in);
            System.out.println("Console mode finished.");
        }
        else if ((args[0].compareTo("-s") == 0) || (args[0].compareTo("--script") == 0)) {
            fennix.loadInitTools();
            try {
                BufferedReader reader = new BufferedReader(new FileReader(args[1]));
                fennix.runScriptReader(reader, false);
                reader.close();
                System.out.println("Script executed.");
            }
            catch (FileNotFoundException fe) {
                System.out.println("Error. The file: \"" + args[1] + "\" was not found.");
            }
            catch (IOException ie) {
                System.out.println("Input/Ouptput error.");
            }
        }
        else {
            if ((args[0].compareTo("-h") != 0) && (args[0].compareTo("--help") != 0)) {
                System.out.println();
                System.out.println("Unknown argument!!");
                System.out.println();
            }
            System.out.println("FENNIX usage:");
            System.out.println("FENNIX -c\t\t\t-> enters console mode.");
            System.out.println("FENNIX --console\t\t-> enters console mode.");
            System.out.println("FENNIX -s \"fileName\"\t\t-> launch script \"fileName\".");
            System.out.println("FENNIX --script \"fileName\"\t-> launch script \"fileName\".");
        }

    }
    
    private void initCreatedComponents() {
        console = new VirtualConsole (jTextAreaConsole);

        objects = fennix.getVariables();
        plugins = fennix.getPlugins();
        
//        workspace = new Workspace(this, false, fennix.getObjects(), fennix.getPlugins());
//        workspace.loadInitTools();
        workspace = new Workspace(this, false, fennix);
        workspace.loadInitTools();
                
        filePath = null;
        
        jListNewObject.setModel(workspace.getToolList().getModel());
        jListCallFunction.setModel(workspace.getFunctionList().getModel());
        editing = false;

        jTextFieldCommands.requestFocusInWindow();

    }

    static private FennixCore fennix;
    
    private Hashtable<String, Object> objects;
    private Hashtable<String, Class> plugins;
    private Workspace workspace;
    private File filePath;
    
    private DefaultMutableTreeNode algorithmList;
    private DefaultTreeModel algorithmListModel;
    private DefaultMutableTreeNode selectedNode;
    private boolean editing;

    private VirtualConsole console;

  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupAddAppend;
    private javax.swing.JButton jButtonCall;
    private javax.swing.JButton jButtonCancelCallFunction;
    private javax.swing.JButton jButtonCancelNewObject;
    private javax.swing.JButton jButtonDeleteNodes;
    private javax.swing.JButton jButtonEndExperiment;
    private javax.swing.JButton jButtonLoadExperiment;
    private javax.swing.JButton jButtonLoadTree;
    private javax.swing.JButton jButtonNew;
    private javax.swing.JButton jButtonOKVisualAssign;
    private javax.swing.JButton jButtonPauseResumeExperiment;
    private javax.swing.JButton jButtonRunExperiment;
    private javax.swing.JButton jButtonSaveExperiment;
    private javax.swing.JButton jButtonSaveTree;
    private javax.swing.JButton jButtonTranslate;
    private javax.swing.JButton jButtonVar;
    private javax.swing.JDialog jDialogAbout;
    private javax.swing.JDialog jDialogCallFunction;
    private javax.swing.JDialog jDialogNewObject;
    private javax.swing.JDialog jDialogVisualAssign;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jListCallFunction;
    private javax.swing.JList jListNewObject;
    private javax.swing.JMenuBar jMenuBarFennix;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenu jMenuHelp;
    private javax.swing.JMenuItem jMenuItemAbout;
    private javax.swing.JMenuItem jMenuItemClearConsole;
    private javax.swing.JMenuItem jMenuItemDeleteAllNodes;
    private javax.swing.JMenuItem jMenuItemDeleteNode;
    private javax.swing.JMenuItem jMenuItemEditNode;
    private javax.swing.JMenuItem jMenuItemLoadWorkspace;
    private javax.swing.JMenuItem jMenuItemSaveWorkspace;
    private javax.swing.JMenuItem jMenuItemShowWorkspace;
    private javax.swing.JPanel jPanelCommands;
    private javax.swing.JPanel jPanelControl;
    private javax.swing.JPanel jPanelCreation;
    private javax.swing.JPanel jPanelExperiment;
    private javax.swing.JPanel jPanelGraphicScript;
    private javax.swing.JPanel jPanelNodesControl;
    private javax.swing.JPanel jPanelTextScript;
    private javax.swing.JPopupMenu jPopupMenuConsole;
    private javax.swing.JPopupMenu jPopupMenuExperiment;
    private javax.swing.JRadioButton jRadioButtonAppend;
    private javax.swing.JRadioButton jRadioButtonInsert;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JScrollPane jScrollPaneConsole;
    private javax.swing.JScrollPane jScrollPaneExperiment;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTabbedPane jTabbedPaneExperiment;
    private javax.swing.JTextArea jTextAreaConsole;
    private javax.swing.JTextArea jTextAreaTextScript;
    private javax.swing.JTextField jTextFieldCommands;
    private javax.swing.JTextField jTextFieldVisualAssign;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTree jTreeNodes;
    // End of variables declaration//GEN-END:variables
    
}
