/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXDisconnectInput;

import visualFNNXDisconnectInput.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networks.AbstractFNNXFeedForwardNetwork;
import model.distributedRepresentation.AbstractPerceptronBase;
import scripting.InterThreadMonitor;
import scripting.Names;

/**
 *
 * @author hsatizab
 */
public class FNNXDisconnectInput extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXDisconnectInput(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "input";

        parameterTypes = new Class[2];
        parameterTypes[0] = AbstractFNNXFeedForwardNetwork.class;
        parameterTypes[1] = Number.class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXDisconnectInput(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "input";
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            network = (AbstractFNNXFeedForwardNetwork)parameters[0];
            input = ((Number)parameters[1]).intValue();

            if (network == null) {
                monitor.appendErrorMessage("Error. No network to disconnect input.");
                return false;
            }

            if ((input < 0) || (input > network.getFirstLayer().getAmountOfUnits())) {
                monitor.appendErrorMessage("Error. Input number must be greater than zero, and smaller than the number of inputs.");
                return false;
            }
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        ((AbstractPerceptronBase)network.getFirstLayer().getAt(input)).setUse(false);
        
        return null;

    }

    private AbstractFNNXFeedForwardNetwork network;
    private int input;

}
