/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXGetDataRow;

import visualFNNXGetDataRow.ConfigurationWindow;
import plugin.*;
import data.DataBlock;
import java.util.Hashtable;
import javax.swing.JFrame;
import scripting.InterThreadMonitor;
import scripting.Names;

/**
 *
 * @author hsatizab
 */
public class FNNXGetDataRow extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXGetDataRow(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[3];
        parameterNames[0] = "datablock";
        parameterNames[1] = "dataset";
        parameterNames[2] = "row";

        parameterTypes = new Class[3];
        parameterTypes[0] = DataBlock.class;
        parameterTypes[1] = Number.class;
        parameterTypes[2] = Number.class;

        isParameterMandatory = new boolean[3];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;
        isParameterMandatory[2] = true;

        parameters = new Object[3];
    }

    public FNNXGetDataRow(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[3];
        parameterNames[0] = "datablock";
        parameterNames[1] = "dataset";
        parameterNames[2] = "row";
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            datablock = (DataBlock)parameters[0];
            dataset = ((Number)parameters[1]).intValue();
            row = ((Number)parameters[2]).intValue();
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }
        
        return datablock.getDataset(dataset).getRow(row);

    }

    private DataBlock datablock;
    private int dataset;
    private int row;

}
