/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXSetInputConnectionMask;

import visualFNNXSetInputConnectionMask.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networks.AbstractFNNXFeedForwardNetwork;
import model.distributedRepresentation.AbstractPerceptronBase;
import scripting.InterThreadMonitor;
import scripting.Names;

/**
 *
 * @author hsatizab
 */
public class FNNXSetInputConnectionMask extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXSetInputConnectionMask(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "mask";

        parameterTypes = new Class[2];
        parameterTypes[0] = AbstractFNNXFeedForwardNetwork.class;
        parameterTypes[1] = Object[].class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXSetInputConnectionMask(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "mask";
    }
    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            network = (AbstractFNNXFeedForwardNetwork)parameters[0];
            if (network == null) {
                monitor.appendErrorMessage("Error. No network to disconnect input.");
                return false;
            }

            try {
                mask = new int[((Object[])parameters[1]).length];
                for (int i = 0; i < mask.length; i++) {
                    mask[i] = ((Number)((Object[])parameters[1])[i]).intValue();
                }
            }
            catch (ClassCastException ce) {
                monitor.appendErrorMessage("Error. The mask must be a vector of 1's and 0's indicating input connection.");
                return false;
            }

            if (mask.length != network.getFirstLayer().getAmountOfUnits()) {
                monitor.appendErrorMessage("Error. The number of elements of the mask must be equal to the number of units in the input layer.");
                return false;
            }
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }
        int i = 0;

        network.getFirstLayer().head();
        while (network.getFirstLayer().hasNode()) {
            if (mask[i] > 0) {
                ((AbstractPerceptronBase)network.getFirstLayer().getUnitDoNext()).setUse(true);
            }
            else {
                ((AbstractPerceptronBase)network.getFirstLayer().getUnitDoNext()).setUse(false);
            }
            i++;
        }
        
        
        return null;

    }

    private AbstractFNNXFeedForwardNetwork network;
    private int[] mask;

}
