/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXUseAllInputs;

import visualFNNXUseAllInputs.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networks.AbstractFNNXFeedForwardNetwork;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;


/**
 *
 * @author hsatizab
 */
public class FNNXUseAllInputs extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXUseAllInputs(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;

        parameterNames = new String[1];
        parameterNames[0] = "network";

        parameterTypes = new Class[1];
        parameterTypes[0] = AbstractFNNXFeedForwardNetwork.class;

        isParameterMandatory = new boolean[1];
        isParameterMandatory[0] = true;

        parameters = new Object[1];
    }

    public FNNXUseAllInputs(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[1];
        parameterNames[0] = "network";

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            network = (AbstractFNNXFeedForwardNetwork)parameters[0];

            if (network == null) {
                monitor.appendErrorMessage("Error. No network to disconnect input.");
                return false;
            }
            results = new InterThreadBuffer(0);
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        network.useAllInputs();

        return null;

    }

    private AbstractFNNXFeedForwardNetwork network;

}
