/*
 * MyDouble.java
 *
 * Created on 12. mai 2006, 15:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package data;

import java.io.Serializable;


/**
 *
 * @author Hector
 */
public class MyDouble implements Cloneable, Serializable {
    
    /**
     * Creates a new instance of MyDouble. This object wraps a double value.
     *
     * @param   d   double value
     */
    public MyDouble(double d) {
        setValue(d);
    }
    
    /**
     * Makes a copy of the MyDouble object in another memory address.
     * 
     * @return  a copy of the {@link MyDouble} object
     * @see Cloneable
     */
    public MyDouble clone() {
        try {
            return (MyDouble) super.clone();
        }
        catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
            return null;
        }
    }
    
    /**
     * Returns the double value contained by the object.
     * 
     * @return  the number contained by the {@link MyDouble} object.
     */
    public final double getValue() {
        return value;
    }
    
    /**
     * Sets the double value contained by the object.
     * 
     * @param   d   double value
     */
    public final void setValue(double d) {
        value = d;
    }
    
    double value;
}
