/*
 * MyFloat.java
 *
 * Created on 30. novembre 2007, 15:13
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package data;

import java.io.Serializable;

/**
 *
 * @author Hector
 */
public class MyFloat implements Cloneable, Serializable {
    
    /**
     * Creates a new instance of MyFloat. This object wraps a float value.
     *
     * @param   d   float value
     */
    public MyFloat(float d) {
        setValue(d);
    }
    
    /**
     * Makes a copy of the MyDouble object in another memory address.
     * 
     * @return  a copy of the {@link MyDouble} object
     * @see Cloneable
     */
    public MyFloat clone() {
        try {
            return (MyFloat) super.clone();
        }
        catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
            return null;
        }
    }
    
    /**
     * Returns the float value contained by the object.
     * 
     * @return  the number contained by the {@link MyDouble} object.
     */
    public final float getValue() {
        return value;
    }
    
    /**
     * Sets the float value contained by the object.
     * 
     * @param   d   float value
     */
    public final void setValue(float d) {
        value = d;
    }
    
    float value;
}
