/*
 * AbstractActivationFunction.java
 *
 * Created on 20. juin 2006, 21:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package model.distributedRepresentation;

import java.io.Serializable;
//import scripting.Names;

/**
 *
 * @author Hector
 */
public abstract class AbstractActivationFunction implements Cloneable, Serializable {
    
    /**
     * Creates a new instance of AbstractActivationFunction.
     */
    public AbstractActivationFunction() {
    }
    
    /**
     * Returns a copy of the object.
     */
    public AbstractActivationFunction clone() {
        try {
            return (AbstractActivationFunction) super.clone();
        }
        catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
            return null;
        }
    }
    
    /**
     * Applies the activation function and returns the resulting value.
     *
     * @param   in  input value
     * @return  the resulting value after appplying the activation function
     */
    public abstract float apply(float in);
    
    /**
     * Calculates the first derivative and returns the resulting value
     *
     * @param   out  output value to calculate the first derivative
     * @return  the resulting value
     */
    public abstract float firstDeriv(float out);
    
}
