/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package plugin;

import java.io.Serializable;
import scripting.Names;

/**
 *
 * @author hector
 */
public abstract class AbstractFNNXFunction extends AbstractFNNXObject implements Serializable, FNNXFunction {

    public int getNumberOfReturningTraces() {
//        if (plotMode == Names.plotModes.none) {
//            return 0;
//        }
        
        try {
            return res.length;
        }
        catch (NullPointerException ne) {
            return 0;
        }
    }

    public void initPlotter(int maxIt, int pt) {
        hasPlotter = false;

        if (plotter != null) {
            if (plotter.own(this)) {
//                plotter.initialize(res.length);
                results.setCommand(Names.interThreadCommands.init, res.length);
                plotter.getMonitor().newResults(results);

//                results.setCommand(Names.interThreadCommands.setPlotterMode, new PlotMode(plotMode, pt));
                plotter.getMonitor().newMessage(plotMode.toString());
                results.setCommand(Names.interThreadCommands.setPlotterMode, pt);
                plotter.getMonitor().newResults(results);

                results.setCommand(Names.interThreadCommands.setMaxIterations, maxIt);
                plotter.getMonitor().newResults(results);

                hasPlotter = true;
            }
        }
    }

    public void initSaver() {
        hasSaver = false;

        if (saver != null) {
            if (saver.own(this)) {
//                saver.initialize(res.length);
                results.setCommand(Names.interThreadCommands.init, res.length);
                saver.getMonitor().newResults(results);

                saver.getMonitor().newMessage(this.toString());
                results.setCommand(Names.interThreadCommands.openFile, 0);
                saver.getMonitor().newResults(results);

                hasSaver = true;
            }
        }
    }

    public void endPlotter() {
        if (hasPlotter) {
            plotter.free();
        }
    }

    public void endSaver() {
        if (hasSaver) {
            saver.free();
        }
    }

//    public abstract void singleStep(int it);
//
//    public void singleStep(int it) {
//        monitor.appendErrorMessage("Error. Single step not implemmented. It must be done in derived classes.");
//        throw new UnsupportedOperationException("Error. This function must be implemented in derived classes.");
//    }

    protected AbstractFNNXParallelObserver plotter;
    protected boolean hasPlotter;

    protected AbstractFNNXParallelObserver saver;
    protected boolean hasSaver;

    protected Names.plotModes plotMode;

    protected float[] res;
}
