/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package plugin;

import java.io.Serializable;
import java.util.Hashtable;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;

/**
 *
 * @author hector
 */
public abstract class AbstractFNNXParallelObserver extends AbstractFNNXObject implements Runnable, Serializable, FNNXObject {

    public InterThreadMonitor getMonitor() {
        return observerMonitor;
    }

    public void terminate() {
        observerMonitor.notRunning();
    }

    public void abort() {
        observerMonitor.abort();
    }

//    public void initialize(int lines) {
//        observerMonitor.changeConfiguration(lines);
//    }

    public boolean configure(Hashtable<String, Object> vars, Hashtable<String, Object> localVars, InterThreadMonitor m) {
        if (super.configure(vars, localVars, m) == false)  {
            return false;
        }

        thread = new Thread(this);

        observerMonitor = new InterThreadMonitor();
        observerMonitor.running();
        
        thread.start();

        return true;
    }

    public boolean own(FNNXObject o) {
        if (owner == null) {
            owner = o;
            return true;
        }
        else {
            if (o == owner) {
                return true;
            }
            else {
                System.out.println("Warning. Object \"" + o.toString() + "\" is trying to use observer \"" + name + "\" but it is being used by higher order function \"" + owner.toString() + "\".");
                return false;
            }
        }
    }

    public void free() {
        owner = null;
    }
    
    protected InterThreadMonitor observerMonitor;
    protected InterThreadBuffer observerResults;
    transient protected Thread thread;

    protected FNNXObject owner;

}
