/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package scripting;

import data.FNNXTreeNode;
import java.io.BufferedReader;
import java.io.IOException;

/**
 *
 * @author hsatizab
 */
public class FNNXLexer {

    public FNNXLexer(BufferedReader f) {
        file = f;
        tokens = new FNNXTreeNode(new FNNXToken(Names.tokens.main, "main", 0), null);
    }

    public FNNXTreeNode analyze() {
        int lineNumber = 0;
        String line;

        try {
            do {
                line = file.readLine();
                if (line != null) {
                    lineNumber++;
                    this.analyze(line, lineNumber);
                }
            }
            while (line != null);
        }
        catch(IOException ie) {
        }

//        tokens.head();
//        while (tokens.hasNode()) {
//            System.out.println(tokens.getDoNext());
//        }

        return tokens;
    }

    public FNNXTreeNode analyze(String text, int line) {
        int index = 0;
        int textLength = text.length();
        char single;
        int indexCopy;
        String sub;
        Names.tokens token;
        int decCount;
        
        while (index < textLength) {
            indexCopy = index;
            single = text.charAt(index);

            if ( ((single >= 'a') && (single <= 'z')) || ((single >= 'A') && (single <= 'Z')) || (single == '_')) {
                while ( ((single >= '0') && (single <= '9')) || ((single >= 'a') && (single <= 'z')) || ((single >= 'A') && (single <= 'Z')) || (single == '_')) {
                    index++;
                    if (index < textLength) {
                        single = text.charAt(index);
                    }
                    else {
                        break;
                    }
                }
                sub = text.substring(indexCopy, index);
                if (sub.compareTo("new") == 0) {
                    token = Names.tokens.create;
                }
                else if (sub.compareTo("call") == 0) {
                    token = Names.tokens.call;
                }
                else if (sub.compareTo("source") == 0) {
                    token = Names.tokens.load;
                }
                else if (sub.compareTo("if") == 0) {
                    token = Names.tokens.cond;
                }
                else if (sub.compareTo("else") == 0) {
                    token = Names.tokens.condElse;
                }
                else if (sub.compareTo("while") == 0) {
                    token = Names.tokens.whileLoop;
                }
                else if (sub.compareTo("min") == 0) {
                    token = Names.tokens.min;
                }
                else if (sub.compareTo("max") == 0) {
                    token = Names.tokens.max;
                }
                else if (sub.compareTo("wMin") == 0) {
                    token = Names.tokens.whereMin;
                }
                else if (sub.compareTo("wMax") == 0) {
                    token = Names.tokens.whereMax;
                }
                else if (sub.compareTo("length") == 0) {
                    token = Names.tokens.length;
                }
                else if (sub.compareTo("show") == 0) {
                    token = Names.tokens.show;
                }
                else if (sub.compareTo("concat") == 0) {
                    token = Names.tokens.concat;
                }
                else if (sub.compareTo("false") == 0) {
                    token = Names.tokens.bool;
                }
                else if (sub.compareTo("true") == 0) {
                    token = Names.tokens.bool;
                }
                else {
                    token = Names.tokens.name;
                }

                tokens.append(new FNNXToken(token, sub, line));
            }

            else {
                switch (single) {
                    case '0':
                    case '1':
                    case '2':
                    case '3':
                    case '4':
                    case '5':
                    case '6':
                    case '7':
                    case '8':
                    case '9':
                        indexCopy = index;
                        index++;
                        decCount = 0;
                        while ( index < textLength ) {
                            single = text.charAt(index);
                            if (! (((single >= '0') && (single <= '9')) || (single == '.')) ) {
                                break;
                            }
                            if (single == '.') {
                                decCount++;
                            }
                            index++;
                        }
                        if (decCount <= 1) {
                            sub = text.substring(indexCopy, index);
                            tokens.append(new FNNXToken(Names.tokens.number, sub, line));
                        }
                        else {
                            tokens.append(new FNNXToken(Names.tokens.error, "error", line));
                        }
                        break;
                    case '=':
                        token = Names.tokens.assign;
                        sub = "=";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '=') {
                                token = Names.tokens.eq;
                                sub += "=";
                                index++;
                            }
                            else if (text.charAt(index) == '<') {
                                token = Names.tokens.lessEq;
                                sub += "<";
                                index++;
                            }
                            else if (text.charAt(index) == '>') {
                                token = Names.tokens.moreEq;
                                sub += ">";
                                index++;
                            }
                            else if (text.charAt(index) == '!') {
                                token = Names.tokens.diff;
                                sub += "!";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case ' ':       //ignore
                    case '\t':      //ignore
                    case '\n':      //ignore
                        index++;
                        while (index < textLength) {
                            if ( (text.charAt(index) == ' ') || (text.charAt(index) == '\t') || (text.charAt(index) == '\n') ) {
                                index++;
                            }
                            else {
                                break;
                            }
                        }
                        break;
                    case ',':
                        tokens.append(new FNNXToken(Names.tokens.sep, ",", line));
                        index++;
                        break;
                    case '.':
                        tokens.append(new FNNXToken(Names.tokens.decimal, ".", line));
                        index++;
                        break;
                    case '"':
                        token = Names.tokens.error;
                        sub = "error";
                        indexCopy = index;
                        index++;
                        while ( index < textLength ) {
                            if (text.charAt(index) == '"') {
                                index++;
                                token = Names.tokens.quot;
                                sub = text.substring(indexCopy, index);
                                break;
                            }
                            index++;
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '+':
                        token = Names.tokens.add;
                        sub = "+";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '+') {
                                token = Names.tokens.inc;
                                sub += "+";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '-':
                        token = Names.tokens.sub;
                        sub = "-";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '-') {
                                token = Names.tokens.dec;
                                sub += "-";
                                index++;
                            }
                            else if (text.charAt(index) == '*') {
                                token = Names.tokens.neg;
                                sub += "*";
                                index++;
                            }
                            else {
                                indexCopy = index;
                                decCount = 0;
                                while ( index < textLength ) {
                                    single = text.charAt(index);
                                    if (! (((single >= '0') && (single <= '9')) || (single == '.')) ) {
                                        break;
                                    }
                                    if (single == '.') {
                                        decCount++;
                                    }
                                    index++;
                                }
                                if (index > indexCopy) {
                                    if (decCount <= 1) {
                                        sub += text.substring(indexCopy, index);
                                        token = Names.tokens.number;
                                    }
                                    else {
                                        sub = "error";
                                        token = Names.tokens.error;
                                    }
                                }
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '*':
                        tokens.append(new FNNXToken(Names.tokens.mult, "*", line));
                        index++;
                        break;
                    case '/':
                        index++;
                        if ( index < textLength ) {
                            if (text.charAt(index) == '/') {
                                index++;
                                while ( index < textLength ) {
                                    if (text.charAt(index) == '\n') {
                                        break;
                                    }
                                    else {
                                        index++;
                                    }
                                }
                            }
                            else {
                                tokens.append(new FNNXToken(Names.tokens.div, "/", line));
                            }
                        }
                        else {
                            tokens.append(new FNNXToken(Names.tokens.div, "/", line));
                        }
                        break;
                    case '%':
                        tokens.append(new FNNXToken(Names.tokens.mod, "%", line));
                        index++;
                        break;
                    case '^':
                        token = Names.tokens.exp;
                        sub = "^";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '^') {
                                token = Names.tokens.xor;
                                sub += "^";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '&':
                        token = Names.tokens.exp;
                        sub = "&";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '&') {
                                sub += "&";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '|':
                        token = Names.tokens.exp;
                        sub = "|";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '|') {
                                sub += "|";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '!':
                        token = Names.tokens.not;
                        sub = "!";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '=') {
                                token = Names.tokens.diff;
                                sub += "=";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '<':
                        token = Names.tokens.less;
                        sub = "<";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '=') {
                                token = Names.tokens.lessEq;
                                sub += "=";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                    case '>':
                        token = Names.tokens.more;
                        sub = ">";
                        index++;
                        if (index < textLength) {
                            if (text.charAt(index) == '=') {
                                token = Names.tokens.moreEq;
                                sub += "=";
                                index++;
                            }
                        }
                        tokens.append(new FNNXToken(token, sub, line));
                        break;
                   case '(':
                        tokens.append(new FNNXToken(Names.tokens.openP, "(", line));
                        index++;
                        break;
                    case ')':
                        tokens.append(new FNNXToken(Names.tokens.closeP, ")", line));
                        index++;
                        break;
                    case '[':
                        tokens.append(new FNNXToken(Names.tokens.openB, "[", line));
                        index++;
                        break;
                    case ']':
                        tokens.append(new FNNXToken(Names.tokens.closeB, "]", line));
                        index++;
                        break;
                    case '{':
                        tokens.append(new FNNXToken(Names.tokens.openA, "{", line));
                        index++;
                        break;
                    case '}':
                        tokens.append(new FNNXToken(Names.tokens.closeA, "}", line));
                        index++;
                        break;
                    default:
                        tokens.append(new FNNXToken(Names.tokens.unknown, String.valueOf(single), line));
                        index++;
                        break;
                }
            }
        }

        return tokens;
    }

    private BufferedReader file;
    private FNNXTreeNode tokens;
}

// assign, space, newLine, sep, decimal, add, sub, mult, div, mod, inc, dec, and, or, not,
// openP, closeP, openB, closeB, openA, closeA,
// diff, eq, less, more, lessEq, moreEq,
// create, call, cond, whileLoop };