/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package scripting;

import data.FNNXTreeNode;
import data.MyLinkedList;

/**
 *
 * @author hsatizab
 */
public class FNNXParser {

    public FNNXParser() {
    }

    public FNNXTreeNode parse(FNNXTreeNode tokens) {
        MyLinkedList stack = new MyLinkedList();
        int i, j, k, m;
        FNNXTreeNode newNode = null;
        boolean flag;

//            System.out.println("\nparsing...");
//            tokens.show();
//            System.out.println();

        k = 0;
        tokens.tail();
        while (tokens.hasNode()) {
            stack.head();
            stack.insert(tokens.getCurrent());

//                System.out.println("Testing...");
//                stack.head();
//                while (stack.hasNode()) {
//                    System.out.println(stack.getDoNext().toString());
//                }

            flag = true;
            for (i = 0; i < rules.length; i++) {
                m = rules[i].match(stack, groups);
                if (m > 0) {
                    k++;
                    newNode = new FNNXTreeNode(new FNNXToken(rules[i].getName(), rules[i].toString(), 0), tokens);
                    tokens.insertNode(newNode);
                    tokens.previous();
                    for (j = 0; j < m; j++) {
//                            tokens.debug();
                        tokens.next();
                        newNode.appendNode((FNNXTreeNode)tokens.getCurrent());
                        tokens.deleteCurrentDoPrevious();
//                            tokens.debug();

                        stack.deleteFirst();
                    }

//                        System.out.println("Inserted: " + rules[i].getName().toString());

                    flag = false;

                    break;
                }
            }

            if (flag == true) {
                tokens.previous();
            }
        }

        return tokens;
    }

    public void clean(FNNXTreeNode root) {
        FNNXTreeNode currentNode;
        FNNXToken currentToken;
        
        root.head();
        while (root.hasNode()) {
            currentNode = (FNNXTreeNode)root.getCurrent();
            currentToken = (FNNXToken)currentNode.getObject();

            switch (currentToken.getToken()) {
                case As:
                case CrOb:
//                case CrObLoBl:
                case CrObBl:
                case CaFu:
//                case CaFuLoBl:
                case CaFuBl:
//                case LoBl:
//                case GlBl:
                case So:
                case Bl:
                case Ve:
                case WhLo:
                case In:
                case Ve1:
//                case Ne:
                case Ex:
                case Ex3:
                case Ex2Pre:
                case Ex2Post:
                case LoEx:
                case Mi:
                case Ma:
                case WhMi:
                case WhMa:
                case Le:
                case Sh:
                case Cat:
                case IfBl:
                    this.clean(currentNode);
                    root.next();
                    break;

                case ObNa:
                case El:
                case Co:
                case Ne:
//                case Ex:
                    this.clean(currentNode);
//                    root.insertNode((FNNXTreeNode)currentNode.getFirst());
//                    currentNode.deleteFirst();
//                    root.deleteCurrentDoNext();
                    currentNode.head();
                    while (currentNode.size() > 0) {
                        root.insertNode((FNNXTreeNode)currentNode.getFirst());
                        currentNode.deleteFirst();
                    }
                    root.deleteCurrentDoNext();
                    break;

                case assign:
                case openP:
                case closeP:
                case openB:
                case closeB:
                case openA:
                case closeA:
                case load:
                case sep:
                case create:
                case call:
                case whileLoop:
                case min:
                case max:
                case whereMin:
                case whereMax:
                case length:
                case show:
                case concat:
                case cond:
                    root.deleteCurrentDoNext();
                    break;

                default:
                    root.next();
                    break;
            }
        }
    }

    public boolean checkErrors(FNNXTreeNode root) {
        boolean syntaxOK = true;
        FNNXTreeNode current;
        FNNXToken currentToken;
        int lineNumber;

        root.head();
        while (root.hasNode() && syntaxOK) {
            current = (FNNXTreeNode)root.getDoNext();
            currentToken = (FNNXToken)current.getObject();
            switch (currentToken.getToken()) {
                case As:
                case CaFu:
                case CaFuLoBl:
                case CaFuBl:
//                case CrOb:
//                case CrObLoBl:
                case So:
                case Ex:
                case Ex2Post:
                case Sh:
                case Cat:
                    syntaxOK = true;
                    break;

                case WhLo:
                    syntaxOK = this.checkErrors((FNNXTreeNode)current.getLast());
                    break;

                case IfBl:
                    syntaxOK = this.checkErrors((FNNXTreeNode)current.getLast());
                    break;
                    
                default:
                    lineNumber = currentToken.getLineNumber();
                    if (lineNumber > 0) {
                        System.out.println("Error. Misplaced " + currentToken.getText() + " in line " + String.valueOf(lineNumber) + ".");
                    }
                    else {
                        System.out.println("Syntax error in line " + String.valueOf(lineNumber) + ". Misplaced " + currentToken.getToken().name() + ".");
                    }
                    return false;
            }
        }

        return syntaxOK;
    }

    private FNNXTokenGroup[] groups = {
                            new FNNXTokenGroup(Names.tokens.Ex, new Names.tokens[] {    Names.tokens.name,
                                                                                        Names.tokens.bool,
                                                                                        Names.tokens.Cat,
                                                                                        Names.tokens.number,
                                                                                        Names.tokens.Ve,
                                                                                        Names.tokens.In,
                                                                                        Names.tokens.Ex3,
                                                                                        Names.tokens.Ex2Pre,
                                                                                        Names.tokens.Ex2Post,
                                                                                        Names.tokens.CaFu,
                                                                                        Names.tokens.CaFuBl,
                                                                                        Names.tokens.CrOb,
                                                                                        Names.tokens.CrObBl,
                                                                                        Names.tokens.Le,
                                                                                        Names.tokens.WhMa,
                                                                                        Names.tokens.WhMi,
                                                                                        Names.tokens.Ma,
                                                                                        Names.tokens.Mi }),
                            new FNNXTokenGroup(Names.tokens.LoEx, new Names.tokens[] {  Names.tokens.LoEx3,
                                                                                        Names.tokens.LoEx2Pre }),
                            new FNNXTokenGroup(Names.tokens.CaFu, new Names.tokens[] {  Names.tokens.CaFuBl }),
                            new FNNXTokenGroup(Names.tokens.CrOb, new Names.tokens[] {  Names.tokens.CrObBl })
    };

    private FNNXParserRule[] rules = {      //the initial rules have more priority than the last ones
                                            //star (*) indicates a priority constraint

// Variable assignation
    /* quot */              new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.quot }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
    /* Ex */                new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),

                            new FNNXParserRule(Names.tokens.Bl, new Names.tokens[] { Names.tokens.openA, Names.tokens.CaFu, Names.tokens.As, Names.tokens.Ex2Post, Names.tokens.WhLo, Names.tokens.Sh, Names.tokens.IfBl, Names.tokens.closeA }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.single }),
/* (*) */                   new FNNXParserRule(Names.tokens.ObNa, new Names.tokens[] { Names.tokens.openP, Names.tokens.name, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.CrOb, new Names.tokens[] { Names.tokens.create, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.CrObBl, new Names.tokens[] { Names.tokens.CrOb, Names.tokens.Bl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.CaFu, new Names.tokens[] { Names.tokens.call, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.CaFuBl, new Names.tokens[] { Names.tokens.CaFu, Names.tokens.Bl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.So, new Names.tokens[] { Names.tokens.load, Names.tokens.openP, Names.tokens.quot, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.So, new Names.tokens[] { Names.tokens.load, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.So, new Names.tokens[] { Names.tokens.load, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.WhLo, new Names.tokens[] { Names.tokens.whileLoop, Names.tokens.LoEx, Names.tokens.Bl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.IfBl, new Names.tokens[] { Names.tokens.cond, Names.tokens.LoEx, Names.tokens.Bl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Mi, new Names.tokens[] { Names.tokens.min, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ma, new Names.tokens[] { Names.tokens.max, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.WhMi, new Names.tokens[] { Names.tokens.whereMin, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.WhMa, new Names.tokens[] { Names.tokens.whereMax, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Mi, new Names.tokens[] { Names.tokens.min, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ma, new Names.tokens[] { Names.tokens.max, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.WhMi, new Names.tokens[] { Names.tokens.whereMin, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.WhMa, new Names.tokens[] { Names.tokens.whereMax, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.quot, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.LoEx, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Cat, new Names.tokens[] { Names.tokens.concat, Names.tokens.openP, Names.tokens.El, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Cat, new Names.tokens[] { Names.tokens.concat, Names.tokens.openP, Names.tokens.El, Names.tokens.quot, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),

// Expressions. In order to reduce the number of rules, everything returning a value is an expression
//    /* number */            new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* name */              new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* Ve */                new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ve }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* In */                new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.In }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* Ex3 */               new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex3 }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* Ex2Pre */            new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Pre }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* Ex2Post */           new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Post }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* LoEx3 */             new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.LoEx3 }, new Names.tokenFreq[] { Names.tokenFreq.single }),
//    /* LoEx2Pre */          new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.LoEx2Pre }, new Names.tokenFreq[] { Names.tokenFreq.single }),

// Arithmetic
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.exp, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.Ex, Names.tokens.inc }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.Ex, Names.tokens.dec }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex2Pre, new Names.tokens[] { Names.tokens.neg, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex2Pre, new Names.tokens[] { Names.tokens.dec, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ex2Pre, new Names.tokens[] { Names.tokens.inc, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),

// Logic
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.eq, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.diff, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.less, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.lessEq, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.more, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.moreEq, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.LoEx, Names.tokens.and, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.LoEx, Names.tokens.or, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx3, new Names.tokens[] { Names.tokens.LoEx, Names.tokens.xor, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.LoEx2Pre, new Names.tokens[] { Names.tokens.not, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),

// Vector
                            new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.quot, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.Ex, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
//                            new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.Ex, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                            new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                            new FNNXParserRule(Names.tokens.In, new Names.tokens[] { Names.tokens.Ex, Names.tokens.openB, Names.tokens.Ex, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),

    /* associative */       new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.openP, Names.tokens.Ex3, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
    /* associative */       new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.openP, Names.tokens.Ex2Pre, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
    /* associative */       new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.openP, Names.tokens.Ex2Post, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
    /* associative */       new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.openP, Names.tokens.LoEx, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single })

    };

    private FNNXParserRule[] rules_old = {  new FNNXParserRule(Names.tokens.ObNa, new Names.tokens[] { Names.tokens.openP, Names.tokens.name, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CrOb, new Names.tokens[] { Names.tokens.create, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CrObLoBl, new Names.tokens[] { Names.tokens.CrOb, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoBl, new Names.tokens[] { Names.tokens.openA, Names.tokens.As, Names.tokens.closeA}, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CrOb }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.quot }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CrObLoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CaFu, new Names.tokens[] { Names.tokens.call, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CaFuLoBl, new Names.tokens[] { Names.tokens.CaFu, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CaFuLoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ne, new Names.tokens[] { Names.tokens.sub, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ne, new Names.tokens[] { Names.tokens.sub, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex2Pre }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex2Post }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.number, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.name, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.quot, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.number, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.name, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.name, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.number, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.In, new Names.tokens[] { Names.tokens.name, Names.tokens.Ve1 }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ve }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ve1 }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.In }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.and}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.or}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.not}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.eq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.diff}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.less}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.lessEq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.more}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.moreEq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.LoOp, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.LoOp, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.LoOp, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.LoOp, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.diff, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.diff, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.diff, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.diff, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.eq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.eq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.eq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.eq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.less, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.less, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.less, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.less, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.lessEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.lessEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.lessEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.lessEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.more, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.more, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.more, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.more, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.moreEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.moreEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.moreEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.moreEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.name, Names.tokens.inc }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.name, Names.tokens.dec }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.GlBl, new Names.tokens[] { Names.tokens.openA, Names.tokens.CaFu, Names.tokens.CaFuLoBl, Names.tokens.As, Names.tokens.Ex, Names.tokens.WhLo, Names.tokens.Sh, Names.tokens.IfBl, Names.tokens.closeA }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Co, new Names.tokens[] { Names.tokens.openP, Names.tokens.LoEx, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhLo, new Names.tokens[] { Names.tokens.whileLoop, Names.tokens.Co, Names.tokens.GlBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhLo, new Names.tokens[] { Names.tokens.whileLoop, Names.tokens.Co, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Pre, new Names.tokens[] { Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex3}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Pre}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Post}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Co }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Mi, new Names.tokens[] { Names.tokens.min, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ma, new Names.tokens[] { Names.tokens.max, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhMi, new Names.tokens[] { Names.tokens.whereMin, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhMa, new Names.tokens[] { Names.tokens.whereMax, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Mi}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ma}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.WhMi}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.WhMa}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Le}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.number, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.quot, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.IfBl, new Names.tokens[] { Names.tokens.cond, Names.tokens.Co, Names.tokens.GlBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.IfBl, new Names.tokens[] { Names.tokens.cond, Names.tokens.Co, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single })
    };

}
