/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package scripting;

import data.FNNXTreeNode;
import data.MyLinkedList;

/**
 *
 * @author hsatizab
 */
public class FNNXParserRule {

    public FNNXParserRule(Names.tokens n, Names.tokens[] t, Names.tokenFreq[] f) {
        name = n;
        tokens = t;
        frequency = f;

        jokers = new MyLinkedList();
        effectiveLength = tokens.length;
        for (int i = 0; i < frequency.length; i++) {
            if (frequency[i] == Names.tokenFreq.anyUnordered) {
                jokers.append(tokens[i]);
                effectiveLength--;
            }
            else {
                if (frequency[i] == Names.tokenFreq.any) {
                    effectiveLength--;
                }
            }
        }
    }

    public int match(MyLinkedList stack, FNNXTokenGroup[] groups) {
        if (stack.size() < effectiveLength) {
            return 0;
        }

        int i, m = 0;
        boolean some = false;
        boolean match = false;
        Names.tokens temp;
        stack.head();
        for (i = 0; (i < tokens.length) && (stack.hasNode()); ) {
            temp = ((FNNXToken)((FNNXTreeNode)stack.getDoNext()).getObject()).getToken();

            switch (frequency[i]) {
                case single:
//                    if (tokens[i] != temp) {
                    if (!compare(tokens[i], temp, groups)) {
                        return 0;
                    }
                    else {
                        i++;
                        m++;
                    }
                    break;

                case some:
//                    if (tokens[i] == temp) {
                    if (compare(tokens[i], temp, groups)) {
                        some = true;
                        m++;
                    }
                    else {
                        i++;
                        if (some == false) {
                            return 0;
                        }
                        else {
                            if (stack.hasNode()) {
                                stack.previous();
                            }
                            else {
                                stack.tail();
                            }
                        }
                        some = false;
                    }
                    break;

                case any:
//                    if (tokens[i] == temp) {
                    if (compare(tokens[i], temp, groups)) {
                        m++;
                    }
                    else {
                        i++;
                        if (stack.hasNode()) {
                            stack.previous();
                        }
                        else {
                            stack.tail();
                        }
                    }
                    break;
                    
                case anyUnordered:
                    match = false;
                    while ((i+1) < frequency.length) {
                        if (frequency[i+1] == Names.tokenFreq.anyUnordered) {
                            i++;
                        }
                        else {
                            break;
                        }
                    }

                    match = false;
                    jokers.head();
                    while (jokers.hasNode()) {
//                        if (temp == jokers.getDoNext()) {
                        if (compare((Names.tokens)jokers.getDoNext(), temp, groups)) {
                            m++;
                            match = true;
                            break;
                        }
                    }
                    if (!match) {
                        i++;
                        if (stack.hasNode()) {
                            stack.previous();
                        }
                        else {
                            stack.tail();
                        }
                    }
                    break;
            }

        }

//        c = tokens.length - 1;
//        while ((frequency[c] == Names.tokenFreq.any) && (c < 0)) {        //Error ? (c > 0)?, and rule with "any" at the last token does not exist
//            c--;
//        }
//        c++;
//        if (i < c) {
//            return 0;
//        }
//        else {
//            return m;
//        }
        return m;
    }

    public boolean compare(Names.tokens tokenFromRule, Names.tokens tokenFromTree, FNNXTokenGroup[] groups) {
        int i;
        if (tokenFromRule == tokenFromTree) {
            return true;
        }
        else {
            for (i = 0; i < groups.length; i++) {
                if (tokenFromRule == groups[i].getName()) {
                    if (groups[i].contains(tokenFromTree)) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    public int getSize() {
        return tokens.length;
    }

    public Names.tokens getName() {
        return name;
    }

    public String toString() {
        return name.toString();
    }

    public Names.tokenFreq getFrequency(int f) {
        return frequency[f];
    }

    private Names.tokens name;
    private Names.tokens[] tokens;
    private Names.tokenFreq[] frequency;
    private MyLinkedList jokers;
    private int effectiveLength;

}
