/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package scripting;

import data.FNNXTreeNode;
import data.MyLinkedList;

/**
 *
 * @author hsatizab
 */
public class FNNXParser_old {

    public FNNXParser_old() {
    }

    public FNNXTreeNode parse(FNNXTreeNode tokens) {
        MyLinkedList stack = new MyLinkedList();
        int i, j, k, m;
        FNNXTreeNode newNode = null;
        boolean flag;

//            System.out.println("\nparsing...");
//            tokens.show();
//            System.out.println();

        k = 0;
        tokens.tail();
        while (tokens.hasNode()) {
            stack.head();
            stack.insert(tokens.getCurrent());

//                System.out.println("Testing...");
//                stack.head();
//                while (stack.hasNode()) {
//                    System.out.println(stack.getDoNext().toString());
//                }

            flag = true;
            for (i = 0; i < rules.length; i++) {
                m = rules[i].match(stack, null);
                if (m > 0) {
                    k++;
                    newNode = new FNNXTreeNode(new FNNXToken(rules[i].getName(), rules[i].toString(), 0), tokens);
                    tokens.insertNode(newNode);
                    tokens.previous();
                    for (j = 0; j < m; j++) {
//                            tokens.debug();
                        tokens.next();
                        newNode.appendNode((FNNXTreeNode)tokens.getCurrent());
                        tokens.deleteCurrentDoPrevious();
//                            tokens.debug();

                        stack.deleteFirst();
                    }

//                        System.out.println("Inserted: " + rules[i].getName().toString());

                    flag = false;

                    break;
                }
            }

            if (flag == true) {
                tokens.previous();
            }
        }

        return tokens;
    }

//    public FNNXTreeNode parse(FNNXTreeNode tokens) {        //with foreseeing
//        MyLinkedList stack = new MyLinkedList();
//        int i, j, m = 0;
//        FNNXTreeNode newNode = null;
//        int r;
//        boolean f;
//
//        int foreseeing = 2;
//
//        tokens.tail();
//        while (tokens.hasNode()) {
//            r = 0;
//            f = true;
//            do {
//                stack.head();
//                stack.insert(tokens.getCurrent());
//                r++;
//                if (tokens.previousHasNode() && (r < foreseeing)) {
//                    tokens.previous();
//                }
//                else {
//                    f = false;
//                }
//            }
//            while (f);
//
//            for (; r > 0; r--) {
//
////                    System.out.println("Testing... " + tokens.getCurrent().toString());
////                    stack.head();
////                    while (stack.hasNode()) {
////                        System.out.println(stack.getDoNext().toString());
////                    }
//
//                for (i = 0; i < rules.length; i++) {
//                    m = rules[i].match(stack);
//                    if (m > 0) {
//                        newNode = new FNNXTreeNode(new FNNXToken(rules[i].getName(), rules[i].toString(), 0), tokens);
//                        tokens.insertNode(newNode);
//                        tokens.previous();
//                        for (j = 0; j < m; j++) {
//                            tokens.next();
//                            newNode.appendNode((FNNXTreeNode)tokens.getCurrent());
//                            tokens.deleteCurrentDoPrevious();
//
//                            stack.deleteFirst();
//                        }
//
//                        r = 0;
//                        break;
//                    }
//                }
//                if ( (m == 0) && (r > 1) ) {
//                    stack.deleteFirst();
//                    tokens.next();
//                }
//            }
//
//            if (m == 0) {
//                tokens.previous();
//            }
//        }
//
//        return tokens;
//    }

    public void clean(FNNXTreeNode root) {
        FNNXTreeNode currentNode;
        FNNXToken currentToken;
        
        root.head();
        while (root.hasNode()) {
            currentNode = (FNNXTreeNode)root.getCurrent();
            currentToken = (FNNXToken)currentNode.getObject();

            switch (currentToken.getToken()) {
                case As:
                case CrOb:
                case CrObLoBl:
                case CaFu:
                case CaFuLoBl:
                case LoBl:
                case GlBl:
                case Ve:
                case WhLo:
                case In:
                case Ve1:
//                case Ne:
                case Ex:
                case Ex2Pre:
                case Mi:
                case Ma:
                case WhMi:
                case WhMa:
                case Le:
                case Sh:
                case IfBl:
                    this.clean(currentNode);
                    root.next();
                    break;

                case ObNa:
                case El:
                case Co:
                case Ne:
                    this.clean(currentNode);
//                    root.insertNode((FNNXTreeNode)currentNode.getFirst());
//                    currentNode.deleteFirst();
//                    root.deleteCurrentDoNext();
                    currentNode.head();
                    while (currentNode.size() > 0) {
                        root.insertNode((FNNXTreeNode)currentNode.getFirst());
                        currentNode.deleteFirst();
                    }
                    root.deleteCurrentDoNext();
                    break;

                case assign:
                case openP:
                case closeP:
                case openB:
                case closeB:
                case openA:
                case closeA:
                case sep:
                case create:
                case call:
                case whileLoop:
                case min:
                case max:
                case whereMin:
                case whereMax:
                case length:
                case show:
                case cond:
                    root.deleteCurrentDoNext();
                    break;

                default:
                    root.next();
                    break;
            }
        }
    }

    public boolean checkErrors(FNNXTreeNode root) {
        boolean syntaxOK = true;
        FNNXTreeNode current;
        FNNXToken currentToken;
        int lineNumber;

        root.head();
        while (root.hasNode() && syntaxOK) {
            current = (FNNXTreeNode)root.getDoNext();
            currentToken = (FNNXToken)current.getObject();
            switch (currentToken.getToken()) {
                case As:
                case CaFu:
                case CaFuLoBl:
                case CrOb:
                case CrObLoBl:
                case Ex:
                case Sh:
                    syntaxOK = true;
                    break;

                case WhLo:
                    syntaxOK = this.checkErrors((FNNXTreeNode)current.getLast());
                    break;

                case IfBl:
                    syntaxOK = this.checkErrors((FNNXTreeNode)current.getLast());
                    break;
                    
                default:
                    lineNumber = currentToken.getLineNumber();
                    if (lineNumber > 0) {
                        System.out.println("Error. Misplaced " + currentToken.getText() + " in line " + String.valueOf(lineNumber) + ".");
                    }
                    else {
                        System.out.println("Syntax error in line " + String.valueOf(lineNumber) + ". Misplaced " + currentToken.getToken().name() + ".");
                    }
                    return false;
            }
        }

        return syntaxOK;
    }

    private FNNXParserRule[] rules = {  new FNNXParserRule(Names.tokens.ObNa, new Names.tokens[] { Names.tokens.openP, Names.tokens.name, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CrOb, new Names.tokens[] { Names.tokens.create, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CrObLoBl, new Names.tokens[] { Names.tokens.CrOb, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoBl, new Names.tokens[] { Names.tokens.openA, Names.tokens.As, Names.tokens.closeA}, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CrOb }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.quot }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CrObLoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CaFu, new Names.tokens[] { Names.tokens.call, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.CaFuLoBl, new Names.tokens[] { Names.tokens.CaFu, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.CaFuLoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ne, new Names.tokens[] { Names.tokens.sub, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ne, new Names.tokens[] { Names.tokens.sub, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex2Pre }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ex2Post }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.number, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.name, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.El, new Names.tokens[] { Names.tokens.quot, Names.tokens.sep }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.number, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.name, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve1, new Names.tokens[] { Names.tokens.openB, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.name, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.number, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ve, new Names.tokens[] { Names.tokens.openB, Names.tokens.El, Names.tokens.quot, Names.tokens.closeB }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.some, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.In, new Names.tokens[] { Names.tokens.name, Names.tokens.Ve1 }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ve }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Ve1 }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.In }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.and}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.or}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.not}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.eq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.diff}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.less}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.lessEq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.more}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoOp, new Names.tokens[] { Names.tokens.moreEq}, new Names.tokenFreq[] { Names.tokenFreq.single}),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.LoOp, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.LoOp, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.LoOp, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
//                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.LoOp, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.diff, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.diff, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.diff, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.diff, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.eq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.eq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.eq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.eq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.less, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.less, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.less, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.less, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.lessEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.lessEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.lessEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.lessEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.more, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.more, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.more, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.more, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.moreEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.moreEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.number, Names.tokens.moreEq, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.LoEx, new Names.tokens[] { Names.tokens.name, Names.tokens.moreEq, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.name, Names.tokens.inc }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Post, new Names.tokens[] { Names.tokens.name, Names.tokens.dec }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.GlBl, new Names.tokens[] { Names.tokens.openA, Names.tokens.CaFu, Names.tokens.CaFuLoBl, Names.tokens.As, Names.tokens.Ex, Names.tokens.WhLo, Names.tokens.Sh, Names.tokens.IfBl, Names.tokens.closeA }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.anyUnordered, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Co, new Names.tokens[] { Names.tokens.openP, Names.tokens.LoEx, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhLo, new Names.tokens[] { Names.tokens.whileLoop, Names.tokens.Co, Names.tokens.GlBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhLo, new Names.tokens[] { Names.tokens.whileLoop, Names.tokens.Co, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex2Pre, new Names.tokens[] { Names.tokens.Ne }, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.add, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.sub, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mult, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.div, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.name, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.name }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.number, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.number }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex3, new Names.tokens[] { Names.tokens.Ex, Names.tokens.mod, Names.tokens.Ex }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex3}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Pre}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ex2Post}, new Names.tokenFreq[] { Names.tokenFreq.single}),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.LoEx }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.As, new Names.tokens[] { Names.tokens.name, Names.tokens.assign, Names.tokens.Co }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Mi, new Names.tokens[] { Names.tokens.min, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ma, new Names.tokens[] { Names.tokens.max, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhMi, new Names.tokens[] { Names.tokens.whereMin, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.WhMa, new Names.tokens[] { Names.tokens.whereMax, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Mi}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Ma}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.WhMi}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.WhMa}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Ex, new Names.tokens[] { Names.tokens.Le}, new Names.tokenFreq[] { Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Le, new Names.tokens[] { Names.tokens.length, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.ObNa }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.Ex, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.number, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.Sh, new Names.tokens[] { Names.tokens.show, Names.tokens.openP, Names.tokens.quot, Names.tokens.closeP }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.IfBl, new Names.tokens[] { Names.tokens.cond, Names.tokens.Co, Names.tokens.GlBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single }),
                                        new FNNXParserRule(Names.tokens.IfBl, new Names.tokens[] { Names.tokens.cond, Names.tokens.Co, Names.tokens.LoBl }, new Names.tokenFreq[] { Names.tokenFreq.single, Names.tokenFreq.single, Names.tokenFreq.single })
    };

}
