/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXInitNetwork;

import visualFNNXInitNetwork.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import model.AbstractFNNXModel;
import scripting.InterThreadMonitor;
import scripting.Names;


/**
 *
 * @author hsatizab
 */
public class FNNXInitNetwork extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXInitNetwork(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[1];
        parameterNames[0] = "network";

        parameterTypes = new Class[1];
        parameterTypes[0] = AbstractFNNXModel.class;

        isParameterMandatory = new boolean[1];
        isParameterMandatory[0] = true;

        parameters = new Object[1];
    }

    public FNNXInitNetwork(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[1];
        parameterNames[0] = "network";

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        if (!this.testCompleteness()) {
            return false;
        }

        for (int i = 0; i < parameterNames.length; i++) {
            try {
                switch (i) {
                    case 0:
                        network = (AbstractFNNXModel)parameters[0];
                        break;
                }
            }
            catch(NullPointerException ne) {
                System.out.println("Warning. Variable \"" + parameterNames[i] + "\" not found when configuring " + this.name + ". Using default value");
            }
            catch(IndexOutOfBoundsException ie) {
                monitor.appendErrorMessage("Internal error. Index out of bounds \"" + String.valueOf(i) + "\" when configuring " + this.name);
                return false;
            }
            catch(ClassCastException ce) {
                monitor.appendErrorMessage("Error. Wrong type in variable \"" + parameterNames[i] + "\" when configuring " + this.name);
                return false;
            }
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        network.initModel();

        return null;

    }

    private AbstractFNNXModel network;

}
