/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXTestFunction;

import java.util.Hashtable;
import javax.swing.JFrame;
import plugin.AbstractFNNXFunction;
import plugin.AbstractFNNXParallelObserver;
import plugin.FNNXFunction;
import plugin.FNNXObject;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;
import scripting.Names;
import toolFNNXTestObject.FNNXTestObject;
import visualFNNXTestFunction.ConfigurationWindow;

/**
 *
 * @author hsatizab
 */
public class FNNXTestFunction extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXTestFunction(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.YvsT_single;

        parameterNames = new String[4];
        parameterNames[0] = "plotter";
        parameterNames[1] = "saver";
        parameterNames[2] = "testObject";
        parameterNames[3] = "delay";

        parameterTypes = new Class[4];
        parameterTypes[0] = AbstractFNNXParallelObserver.class;
        parameterTypes[1] = AbstractFNNXParallelObserver.class;
        parameterTypes[2] = FNNXTestObject.class;
        parameterTypes[3] = Number.class;

        isParameterMandatory = new boolean[4];
        isParameterMandatory[0] = false;
        isParameterMandatory[1] = false;
        isParameterMandatory[2] = true;
        isParameterMandatory[3] = true;

        parameters = new Object[4];
    }

    public FNNXTestFunction(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[4];
        parameterNames[0] = "plotter";
        parameterNames[1] = "saver";
        parameterNames[2] = "testObject";
        parameterNames[3] = "delay";
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            plotter = (AbstractFNNXParallelObserver)parameters[0];
            saver = (AbstractFNNXParallelObserver)parameters[1];
            testObject = (FNNXTestObject)parameters[2];
            delay = ((Number)parameters[3]).intValue();

            res = new float[1];
            results = new InterThreadBuffer(res.length);
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        int c;

        initPlotter(testObject.getTo(), 1);
        initSaver();

        try {
            for (testObject.init(); testObject.isNotEnd() && monitor.isRunning(); testObject.step()) {
                while (monitor.isPaused()) {
                }
                c = testObject.getCounter();
                if (hasSaver) {
                    res[0] = (float)c/100;
                    results.newData(res, c);
                    saver.getMonitor().newResults(results);
                }
                if (hasPlotter) {
                    res[0] = (float)c/100;
                    results.newData(res, c);
                    plotter.getMonitor().newResults(results);
                }
                Thread.sleep(delay);
            }
        }
        catch(InterruptedException ie) {
        }

        this.endPlotter();
        this.endSaver();

        return null;
    }

    private FNNXTestObject testObject;
    private int delay;

}
