/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXTestObject;

import java.util.Hashtable;
import javax.swing.JFrame;
import plugin.AbstractFNNXObject;
import plugin.FNNXObject;
import scripting.InterThreadMonitor;
import visualFNNXTestObject.ConfigurationWindow;

/**
 *
 * @author hsatizab
 */
public class FNNXTestObject extends AbstractFNNXObject implements FNNXObject {

    public FNNXTestObject(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[3];
        parameterNames[0] = "from";
        parameterNames[1] = "to";
        parameterNames[2] = "increment";

    }

    public FNNXTestObject(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;

        parameterNames = new String[3];
        parameterNames[0] = "from";
        parameterNames[1] = "to";
        parameterNames[2] = "increment";

        parameterTypes = new Class[3];
        parameterTypes[0] = Number.class;
        parameterTypes[1] = Number.class;
        parameterTypes[2] = Number.class;

        isParameterMandatory = new boolean[3];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;
        isParameterMandatory[2] = true;

        parameters = new Object[3];

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            from = ((Number)parameters[0]).intValue();
            to = ((Number)parameters[1]).intValue();
            increment = ((Number)parameters[2]).intValue();
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public int getCounter() {
        return counter;
    }

    public int getTo() {
        return to;
    }

    public void step() {
        counter += increment;
    }

    public void init() {
        counter = from;
    }

    public boolean isNotEnd() {
        return (counter < to);
    }

    private int from;
    private int to;
    private int increment;
    private int counter;
}
