/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXAnchorGNGNetwork;

import cellGNG.AbstractGNGCell;
import cellGNG.Edge;
import visualFNNXAnchorGNGNetwork.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networkGNG.AbstractFNNXGNGNetwork;
import scripting.InterThreadMonitor;
import scripting.Names;


/**
 *
 * @author hsatizab
 */
public class FNNXAnchorGNGNetwork extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXAnchorGNGNetwork(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "weightFactor";

        parameterTypes = new Class[2];
        parameterTypes[0] = AbstractFNNXGNGNetwork.class;
        parameterTypes[1] = Number.class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXAnchorGNGNetwork(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "weightFactor";

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        if (!this.testCompleteness()) {
            return false;
        }

        for (int i = 0; i < parameterNames.length; i++) {
            try {
                switch (i) {
                    case 0:
                        network = (AbstractFNNXGNGNetwork)parameters[i];
                        break;
                    case 1:
                        weightFactor = ((Number)parameters[i]).floatValue();
                        if (!testMin(i, weightFactor, 0)) {
                            return false;
                        }
                        break;
                }
            }
            catch(NullPointerException ne) {
                System.out.println("Warning. Variable \"" + parameterNames[i] + "\" not found when configuring " + this.name + ". Using default value");
            }
            catch(IndexOutOfBoundsException ie) {
                monitor.appendErrorMessage("Internal error. Index out of bounds \"" + String.valueOf(i) + "\" when configuring " + this.name);
                return false;
            }
            catch(ClassCastException ce) {
                monitor.appendErrorMessage("Error. Wrong type in variable \"" + parameterNames[i] + "\" when configuring " + this.name);
                return false;
            }
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        network.firstCell();
        while (network.hasCell()) {
            ((AbstractGNGCell)network.getCellDoNext()).anchorCell(weightFactor);
        }
        
        return null;

    }

    private AbstractFNNXGNGNetwork network;
    private float weightFactor;

}
