/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXExportGNGMapNetwork;

import cellGNGMap.GNGMapCell;
import cellGNGMap.GNGMapLink;
import visualFNNXExportGNGMapNetwork.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networkGNGMap.AbstractFNNXGNGMap;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;
import scripting.Names;
import toolFNNXExportGNGNetwork.FNNXExportGNGNetwork;


/**
 *
 * @author hsatizab
 */
public class FNNXExportGNGMapNetwork extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXExportGNGMapNetwork(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";

        parameterTypes = new Class[2];
        parameterTypes[0] = AbstractFNNXGNGMap.class;
        parameterTypes[1] = AbstractFNNXParallelObserver.class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXExportGNGMapNetwork(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        if (!this.testCompleteness()) {
            return false;
        }

        for (int i = 0; i < parameterNames.length; i++) {
            try {
                switch (i) {
                    case 0:
                        network = (AbstractFNNXGNGMap)parameters[i];
                        break;

                    case 1:
                        saver = (AbstractFNNXParallelObserver)parameters[1];
                        break;
                }
            }
            catch(NullPointerException ne) {
                monitor.appendErrorMessage("Internal error. Null pointer.");
                return false;
            }
            catch(IndexOutOfBoundsException ie) {
                monitor.appendErrorMessage("Internal error. Index out of bounds.");
                return false;
            }
            catch(ClassCastException ce) {
                monitor.appendErrorMessage("Internal error. Class cast.");
                return false;
            }
        }

        res = new float[3];
        results = new InterThreadBuffer(res.length);

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        int i;
        boolean flag;
        GNGMapCell temp;
        GNGMapLink tempLink;
        FNNXExportGNGNetwork exportGNG;
        exportGNG = new FNNXExportGNGNetwork(null, monitor);

//        network.inventory();

        flag = true;
        flag &= exportGNG.configure(exportGNG.getParameterIndex("network"), network.getInputLayer(), monitor);
        flag &= exportGNG.configure(exportGNG.getParameterIndex("saver"), saver, monitor);
        flag &= exportGNG.prepare(monitor);
        if (!flag) {
            monitor.appendErrorMessage("Error. Impossible to configure for the input layer.");
            return null;
        }
        if (monitor.isRunning()) {
            exportGNG.eval(monitor);
        }

        flag = true;
        flag &= exportGNG.configure(exportGNG.getParameterIndex("network"), network.getOutputLayer(), monitor);
        flag &= exportGNG.configure(exportGNG.getParameterIndex("saver"), saver, monitor);
        flag &= exportGNG.prepare(monitor);
        if (!flag) {
            monitor.appendErrorMessage("Error. Impossible to configure for the output layer.");
            return null;
        }
        if (monitor.isRunning()) {
            exportGNG.eval(monitor);
        }

//------------------------------------------------------------------------------
        this.initSaver();
        
        saver.getMonitor().newMessage("InputIndex\tOutputIndex\tLifeExpectancy");
        results.setCommand(Names.interThreadCommands.writeMessage, 0);
        saver.getMonitor().newResults(results);

        i = 0;
        network.getInputLayer().firstCell();
        while (network.getInputLayer().hasCell() && monitor.isRunning()) {
            temp = (GNGMapCell) network.getInputLayer().getCellDoNext();

            temp.firstLink();
            while (temp.hasLink()) {
                tempLink = temp.getLinkDoNext();
                res[0] = tempLink.getFrom().getNumber();
                res[1] = tempLink.getTo().getNumber();
                res[2] = tempLink.getWeight();
                results.newData(res, i);
                saver.getMonitor().newResults(results);
                i++;
            }
        }

        this.endSaver();
//------------------------------------------------------------------------------
//        this.initSaver();
//
//        saver.getMonitor().newMessage("InputIndex\tOutputIndex\tLifeExpectancy");
//        results.setCommand(Names.interThreadCommands.writeMessage, 0);
//        saver.getMonitor().newResults(results);
//
//        i = 0;
//        network.getOutputLayer().firstCell();
//        while (network.getOutputLayer().hasCell() && monitor.isRunning()) {
//            temp = (GNGMapCell) network.getOutputLayer().getCellDoNext();
//
//            temp.firstLink();
//            while (temp.hasLink()) {
//                tempLink = temp.getLinkDoNext();
//                res[0] = tempLink.getFrom().getNumber();
//                res[1] = tempLink.getTo().getNumber();
//                res[2] = tempLink.getWeight();
//                results.newData(res, i);
//                saver.getMonitor().newResults(results);
//                i++;
//            }
//        }
//
//        this.endSaver();
//------------------------------------------------------------------------------
        
        return null;

    }

    private AbstractFNNXGNGMap network;

}
