/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXExportGNGRBFNetwork;

import cellGNGRBF.GNGRBFCell;
import visualFNNXExportGNGRBFNetwork.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networkGNGRBF.AbstractFNNXGNGRBF;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;
import scripting.Names;
import toolFNNXExportGNGNetwork.FNNXExportGNGNetwork;


/**
 *
 * @author hsatizab
 */
public class FNNXExportGNGRBFNetwork extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXExportGNGRBFNetwork(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.none;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";

        parameterTypes = new Class[2];
        parameterTypes[0] = AbstractFNNXGNGRBF.class;
        parameterTypes[1] = AbstractFNNXParallelObserver.class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXExportGNGRBFNetwork(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";

    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        if (!this.testCompleteness()) {
            return false;
        }

        for (int i = 0; i < parameterNames.length; i++) {
            try {
                switch (i) {
                    case 0:
                        network = (AbstractFNNXGNGRBF)parameters[i];
                        break;

                    case 1:
                        saver = (AbstractFNNXParallelObserver)parameters[1];
                        break;
                }
            }
            catch(NullPointerException ne) {
                monitor.appendErrorMessage("Internal error. Null pointer.");
                return false;
            }
            catch(IndexOutOfBoundsException ie) {
                monitor.appendErrorMessage("Internal error. Index out of bounds.");
                return false;
            }
            catch(ClassCastException ce) {
                monitor.appendErrorMessage("Internal error. Class cast.");
                return false;
            }
        }

        res = new float[1 + network.getAmountOfOutputs()];
        results = new InterThreadBuffer(res.length);

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        int i;
        boolean flag;
        String tempString;
        float[] tempFloat;
        GNGRBFCell temp;
        FNNXExportGNGNetwork exportGNG;
        exportGNG = new FNNXExportGNGNetwork(null, monitor);

//        network.inventory();

        flag = true;
        flag &= exportGNG.configure(exportGNG.getParameterIndex("network"), network.getCompetitionLayer(), monitor);
        flag &= exportGNG.configure(exportGNG.getParameterIndex("saver"), saver, monitor);
        flag &= exportGNG.prepare(monitor);
        if (!flag) {
            monitor.appendErrorMessage("Error. Impossible to configure for the input layer.");
            return null;
        }
        if (monitor.isRunning()) {
            exportGNG.eval(monitor);
        }

//------------------------------------------------------------------------------
        this.initSaver();

        tempString = "CellIndex\tVariance";
        for (i = 0; i < network.getAmountOfOutputs(); i++) {
            tempString += "\tw" + String.valueOf(i);
        }
        saver.getMonitor().newMessage(tempString);
        results.setCommand(Names.interThreadCommands.writeMessage, 0);
        saver.getMonitor().newResults(results);

        network.getCompetitionLayer().firstCell();
        while (network.getCompetitionLayer().hasCell() && monitor.isRunning()) {
            temp = (GNGRBFCell) network.getCompetitionLayer().getCellDoNext();
            tempFloat = temp.getWeights();
            res[0] = temp.getVariance();
            System.arraycopy(tempFloat, 0, res, 1, tempFloat.length);
            results.newData(res, temp.getNumber());
            saver.getMonitor().newResults(results);
        }

        this.endSaver();
//------------------------------------------------------------------------------

        return null;

    }

    private AbstractFNNXGNGRBF network;

}
