/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package layerGNGLLM;

import cellGNGLLM.GNGLLMCell;
import java.util.Random;
import networkGNG.AbstractFNNXGNGNetwork;

/**
 *
 * @author hsatizab
 */
public class FNNXGNGLLMLayerNetwork extends AbstractFNNXGNGNetwork {

    public FNNXGNGLLMLayerNetwork(int nI, int nO) {
        nInputs = nI;
        nOutputs = nO;
        gen = new Random();
        cells = new FNNXGNGLLMLayer(nInputs, nOutputs, gen);
    }

    public void setCurrentInputNoCopy(float[] input) {
        currentInput = input;
    }

    public void setCurrentTargetNoCopy(float[] target) {
        currentTarget = target;
    }

    public float[] calcOutput() {
        this.calcNearest(1);
        return ((GNGLLMCell)near_1).calcOutput(currentInput);
    }

    public float calcLocalError() {
        return ((GNGLLMCell)near_1).calcLocalError(currentTarget);
    }

    public float[] calcLocalErrorByOutput() {
        return ((GNGLLMCell)near_1).calcLocalErrorByOutput(currentTarget);
    }

    public float getLocalError() {
        return ((GNGLLMCell)near_1).getLocalError();
    }

    public void updateSupervised(float eta) {
        ((GNGLLMCell)near_1).updateSupervised(eta, currentInput, currentTarget);
    }

    public void step_4_5_6(float eBest, float eNeighbors, float qError, float hold, float wi, float wd) {
        float localError;

        ((GNGLLMCell)this.near_1).calcOutput(currentInput);
        localError = ((GNGLLMCell)this.near_1).calcLocalError(currentTarget);
        
        this.addToError(this.dNear_1);                                            //cumulated error -> plot

        this.near_1.update(localError, eBest, eNeighbors, wi, wd, this.near_2);
                                                                                //4. Add the squared error between the target and the network output to a local counter variable.
                                                                                //5. Move s1 and its direct topological neighbors towards I.
                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
    }

    private float[] currentTarget;
    private int nOutputs;
}
