/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cellGNGMap;

import cellGNG.AbstractGNGCell;
import data.MyLinkedList;
//import java.util.Random;

/**
 *
 * @author hsatizab
 */
public class GNGMapCell extends AbstractGNGCell {

    /** Creates a new instance of GNGMapCell */
    public GNGMapCell(int nI) {
        edges = new MyLinkedList();

        position = new float[nI];
        dist = new float[nI];

//        Random gen = new Random();
//        for (int i = 0; i < nI; i++) {
//            position[i] = gen.nextFloat();
//        }

        links = new MyLinkedList();
    }

    /** Creates a new instance of GNGMapCell */
    public GNGMapCell(GNGMapCell a, GNGMapCell b) {
        int nI = a.getPosition().length;
//        if (nI != b.getPosition().length) {
//            throw new NullPointerException("Cells with different dimensions");
//        }

        edges = new MyLinkedList();

        position = new float[nI];
        dist = new float[nI];

        for (int i = 0; i < nI; i++) {
            position[i] = (a.getPosition()[i] + b.getPosition()[i]) / 2;
        }

        links = new MyLinkedList();
    }

    public void decreaseLinks(int dec) {
        links.head();
        while (links.hasNode()) {
            ((GNGMapLink)links.getDoNext()).decreaseWeight(dec);
        }
    }

    public void linkTo(GNGMapCell toLink, int inc, int max) {
        links.head();

        while (links.hasNode()) {
            if (((GNGMapLink)links.getCurrent()).getTo() == toLink) {
                ((GNGMapLink)links.getCurrent()).incWeight(inc, max);
                return;
            }
            else {
                links.next();
            }
        }

        GNGMapLink temp = new GNGMapLink(this, toLink, inc);
        links.append(temp);
        toLink.links.append(temp);
    }

    public void decayDifferentBy(GNGMapCell otherCell, int decay) {
        GNGMapLink temp;
        links.head();

        while (links.hasNode()) {
            temp = (GNGMapLink)links.getDoNext();
            if (temp.getTo() != otherCell) {
                temp.decreaseWeight(decay);
            }
        }
    }

    public void deleteUnusedLinks() {
        GNGMapLink temp;
        links.head();
        while (links.hasNode()) {
            temp = (GNGMapLink)links.getCurrent();
            if (temp.getWeight() <= 0) {
                links.deleteCurrentDoNext();
            }
            else {
                links.next();
            }
        }
    }

    public void firstLink() {
        links.head();
    }

    public GNGMapLink getLinkDoNext() {
        return (GNGMapLink)links.getDoNext();
    }

    public boolean hasLink() {
        return links.hasNode();
    }

    public int getAmountOfLinks() {
        return links.size();
    }

    private MyLinkedList links;
}
