/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXGNGNetwork;

import plugin.*;
import data.DataBlock;
import java.util.Hashtable;
import javax.swing.JFrame;
import layerGNG.FNNXGNGLayer;
import networkGNG.AbstractFNNXGNGNetwork;
import scripting.InterThreadMonitor;
import visualFNNXGNGNetwork.ConfigurationWindow;

/**
 *
 * @author hsatizab
 */
public class FNNXGNGNetwork extends AbstractFNNXGNGNetwork implements FNNXObject {

    public FNNXGNGNetwork(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;

        parameterNames = new String[2];
        parameterNames[0] = "inputs";
        parameterNames[1] = "dataset";

        parameterTypes = new Class[2];
        parameterTypes[0] = Number.class;
        parameterTypes[1] = DataBlock.class;

        isParameterMandatory = new boolean[2];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = true;

        parameters = new Object[2];
    }

    public FNNXGNGNetwork(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[2];
        parameterNames[0] = "inputs";
        parameterNames[1] = "dataset";
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        if (!this.testCompleteness()) {
            return false;
        }

        for (int i = 0; i < parameterNames.length; i++) {
            try {
                switch (i) {
                    case 0:
                        nInputs = ((Number)parameters[i]).intValue();
                        if (!testMin(i, nInputs, 0)) {
                            return false;
                        }
                        break;
                        
                    case 1:
                        if (!setDataset((DataBlock)parameters[i])) {
                            monitor.appendErrorMessage("Error. Problems connecting \"" + this.name + " \" to dataset.");
                            return false;
                        }

                        cells = new FNNXGNGLayer(nInputs);
                        this.initModel();
                        break;
                }
            }
            catch(NullPointerException ne) {
                monitor.appendErrorMessage("Warning. Variable \"" + parameterNames[i] + "\" not found when configuring " + this.name + ". Using default value");
            }
            catch(IndexOutOfBoundsException ie) {
                monitor.appendErrorMessage("Internal error. Index out of bounds \"" + String.valueOf(i) + "\" when configuring " + this.name);
                return false;
            }
            catch(ClassCastException ce) {
                monitor.appendErrorMessage("Error. Wrong type in variable \"" + parameterNames[i] + "\" when configuring " + this.name);
                return false;
            }
        }

        configured = true;
        return true;
    }

//    public FNNXGNGNetwork(int nI) {
//        nInputs = nI;
//        if (nInputs < 1) {
//            monitor.appendErrorMessage("Error. The number of inputs must be larger than 1.");
//        }
//        else {
//            cells = new FNNXGNGLayer(nInputs);
//        }
//    }

}
