/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package layerGNGRBF;

import cellGNGRBF.GNGRBFCell;
import java.util.Random;
import networkGNG.AbstractFNNXGNGNetwork;

/**
 *
 * @author hsatizab
 */
public class FNNXGNGRBFLayerNetwork extends AbstractFNNXGNGNetwork {

    public FNNXGNGRBFLayerNetwork(int nI, int nO) {
        nInputs = nI;
        nOutputs = nO;
        gen = new Random();
        cells = new FNNXGNGRBFLayer(nInputs, nOutputs, gen);
        output = new float[nOutputs];
        localErrorO = new float[nOutputs];
    }

    public void setCurrentInputNoCopy(float[] input) {
        currentInput = input;
    }

    public void setCurrentTargetNoCopy(float[] target) {
        currentTarget = target;
    }

    public float[] calcOutput() {
//        int i;
//        float[] temp;
//        for (i = 0; i < nOutputs; i++) {
//            output[i] = 0;
//        }
//
//        cells.head();
//        while (cells.hasNode()) {
//            temp = ((GNGRBFCell)cells.getUnitDoNext()).calcOutput(currentInput);
//            for (i = 0; i < nOutputs; i++) {
//                output[i] += temp[i];
//            }
//        }

        output = ((GNGRBFCell)near_1).calcOutput(currentInput);

        return output;
    }

    public float calcLocalError() {
        int i;

        localError = 0;
        for (i = 0; i < nOutputs; i++) {
            localError += (output[i] - currentTarget[i]) * (output[i] - currentTarget[i]);
        }

        return localError;
    }

    public float[] calcLocalErrorByOutput() {
        int i;

        localError = 0;
        for (i = 0; i < nOutputs; i++) {
            localErrorO[i] = output[i] - currentTarget[i];
            localError += localErrorO[i]*localErrorO[i];
        }

        return localErrorO;
    }

    public float getLocalError() {
        return ((GNGRBFCell)near_1).getLocalError();
    }

    public void step_4_5_6(float eBest, float eNeighbors, float qError, float hold, float wi, float wd) {

        this.addToError(this.dNear_1);                                          //cumulated error -> plot

        this.calcOutput();
        this.near_1.update(this.calcLocalError(), eBest, eNeighbors, wi, wd, this.near_2);
                                                                                //4. Add the squared distance between the input signal and the nearest unit in input space to a local counter variable.
                                                                                //5. Move s1 and its direct topological neighbors towards I.
                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
    }

    public void updateSupervised(float eta) {
        ((GNGRBFCell)near_1).updateSupervised(eta, currentInput, currentTarget);
    }

    private float[] currentTarget;
    private int nOutputs;
    private float localError;
    private float[] localErrorO;
    private float[] output;
}
