/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package networkGNGRBF;

import data.DataBlock;
import java.util.Random;
import layerGNGRBF.FNNXGNGRBFLayerNetwork;
import model.AbstractFNNXSupervisedModel;
import model.FNNXModel;

/**
 *
 * @author hsatizab
 */
public abstract class AbstractFNNXGNGRBF extends AbstractFNNXSupervisedModel implements FNNXModel {

    public int inventory() {
        return competitionLayer.inventory();
    }

    public void initModel() {
        gen = new Random();
        competitionLayer.initModel();
    }

    public void nextExampleRandom() {
        super.nextExampleRandom();
        competitionLayer.setCurrentInputNoCopy(currentInput);

        competitionLayer.setCurrentTargetNoCopy(currentTarget);
    }

    public boolean hasNextExampleSequential() {
        if(super.hasNextExampleSequential()) {
            competitionLayer.setCurrentInputNoCopy(currentInput);

            competitionLayer.setCurrentTargetNoCopy(currentTarget);
            return true;
        }
        else {
            return false;
        }
    }

    public boolean setDataset(DataBlock data) {
        if (!super.setDataset(data)) {
            return false;
        }

        if (!competitionLayer.setDataset(inputDataset)) {
            return false;
        }

        return true;
    }

    public void forget() {
        competitionLayer.forget();
    }

    public float[] calcOutput() {
        competitionLayer.calcNearest(1);
        output = competitionLayer.calcOutput();
        return output;
    }

    public float calcModelError() {
        error = competitionLayer.calcLocalError();
        return error;
    }

    public float[] calcModelErrorByOutput() {
        float[] e = competitionLayer.calcLocalErrorByOutput();
        error = competitionLayer.getLocalError();
        return e;
    }

    public FNNXGNGRBFLayerNetwork getCompetitionLayer() {
        return competitionLayer;
    }

    public void updateSupervised(float eta) {
        competitionLayer.updateSupervised(eta);
    }
    
    public void reset() {
    }

    protected FNNXGNGRBFLayerNetwork competitionLayer;
}
