package cellGNG;

/*
 * Edge.java
 *
 * Created on 26 de septiembre de 2007, 12:02 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.io.Serializable;

/**
 *
 * @author Hector
 */
public class Edge implements Serializable {
    
    /**
     * Creates a new instance of Edge.
     *
     * @param   a   the first unit connected by the edge
     * @param   b   the second unit connected by the edge
     */
    public Edge(AbstractGNGCell a, AbstractGNGCell b) {
        cellA = a;
        cellB = b;
        age = 0;
    }

    /**
     * Returns the age of the edge.
     *
     * @return  the age of the edge
     * @see #setAge(int)
     */
    public int getAge() {
        return age;
    }
    
    /**
     * Sets the value of the age of the edge.
     *
     * @param   a   the new age of the edge
     * @see #getAge()
     */
    public void setAge(int a) {
        age = a;
    }
    
    /**
     * Increments the age of the edge by one.
     */
    public void incrementAge() {
        age++;
    }
    
    /**
     * Returns the unit connected to a given unit by this connector.
     *
     * @param   u   the unit to match
     * @return  the unit connected to the matched unit
     */
    public AbstractGNGCell getUnitConnectedTo(AbstractGNGCell u) {
        if (u == cellA) {
            return cellB;
        }
        else {
            if (u == cellB) {
                return cellA;
            }
            else {
                return null;
            }
        }
    }

    private int age;
    private AbstractGNGCell cellA;
    private AbstractGNGCell cellB;
    
}
