/*
 * GNGNetwork.java
 *
 * Created on 24 de septiembre de 2007, 13:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package networkGNG;

import cellGNG.AbstractGNGCell;
import model.localRepresentation.AbstractFNNXCellNetwork;
import java.util.Random;
import layerGNG.AbstractFNNXGNGLayer;
import model.localRepresentation.AbstractFNNXCell;

/**
 *
 * @author Hector
 */
public abstract class AbstractFNNXGNGNetwork extends AbstractFNNXCellNetwork {
    
    public void initModel() {
        gen = new Random();
        ((AbstractFNNXGNGLayer)cells).initLayer(inputDataset);
    }

    public void forget() {
        
        cells.firstUnit();
        while (cells.hasNode()) {
            if (((AbstractGNGCell)this.cells.getCurrent()).getAmountOfEdges() == 0) {
//                this.cells.deleteCurrentDoNext();
                this.deleteCurrentCellDoNext();
            }
            else {
                this.cells.next();
            }
        }
    }

//    public void decreaseErrors(float d) {
//        cells.firstUnit();
//        while (cells.hasNode()) {
//            ((AbstractGNGCell)cells.getDoNext()).decreaseError(d);
//        }
//    }
    
    public void insertUnit(float a, float s, float qE) {
        float tempError = 0;
        float maxError = Float.MIN_VALUE;
//        double maxError_2 = Double.MIN_VALUE;
        AbstractGNGCell tempCell = null;
        AbstractGNGCell maxErrorCell = null;
        AbstractGNGCell maxErrorCell_2 = null;
        
        AbstractFNNXCell newCell = null;
        
        cells.firstUnit();
        while (cells.hasNode()) {
            tempCell = (AbstractGNGCell)cells.getDoNext();
            tempError = tempCell.getError();
//            System.err.println(tempError);

            if (tempError > maxError) {                                 //Determine the unit q with the maximum accumulated error.
                maxError = tempError;
                maxErrorCell = tempCell;
            }
        }
//        System.err.println("...");

        maxErrorCell_2 = (AbstractGNGCell)maxErrorCell.getNeighborWithLargestError();    //Finding neighbor f having the largest error
        
        //-------------------------------------------------------------
        double dist = Math.sqrt(maxErrorCell.calcDistanceTo(maxErrorCell_2));
        qE = 2 * (float)Math.sqrt(qE);
        s = 1 - s;
        if ( (dist - qE) < (s*qE)) {
            return;
        }
        //-------------------------------------------------------------

        newCell = cells.buildCell();
        ((AbstractGNGCell)newCell).initCell(maxErrorCell, maxErrorCell_2);
        cells.append(newCell);                                                  //Inserts a new unit r halfway between q and its neighbor f
                                                                                //with the largest error variable.
        
        maxErrorCell.deleteConnectionTo(maxErrorCell_2);                //Delete connection between q and f
        maxErrorCell_2.deleteConnectionTo(maxErrorCell);                //Delete connection between q and f
        
        maxErrorCell.connectTo((AbstractGNGCell)newCell);                                //Connects q to r
        maxErrorCell_2.connectTo((AbstractGNGCell)newCell);                              //Connects f to r
        
        maxErrorCell.decreaseError(a);                                  //Decrease the error variables of q
        //maxErrorCell.decreaseWeight();
        maxErrorCell_2.decreaseError(a);                                //and f by multiplying them with a constant alfa.
        //maxErrorCell_2.decreaseWeight();
        newCell.setError(maxErrorCell.getError());                      //Initialize the error variable of r with the new value of the error variable of q.
        //((AbstractGNGCell)newCell).setWeight(maxErrorCell.getWeight());
    }

//    public String toString() {
//        String temp;
//
////        temp = "\n----------------------------------------------------------------\n";
////        temp += "Growing Neural Gas\n";
////        temp += "Competition layer:  " + String.valueOf(this.getNumberOfCells()) + " neurons\n";
////        temp += "----------------------------------------------------------------\n";
//
//        temp = "GNG [" + String.valueOf(this.getNumberOfCells()) + "]";
//        return temp;
//    }
    
//    public void exportNetwork(BufferedWriter bw) {
//        int i;
//
//        try {
//            bw.write("A++ Network Positions File\n\n");
//            bw.write("Index");
//
//            for (i = 1; i <= this.getAmountOfInputs(); i++) {
//                bw.write("\tI_" + String.valueOf(i));
//            }
//            bw.write("\tNeighbours\tIndexes\n");
//
//            this.inventory();
//            GasCell temp;
//            float[] pos;
//            Edge edge;
//            this.firstCell();
//            while (this.hasCell()) {
//                temp = (GasCell) this.getCellDoNext();
//                bw.write(String.valueOf(temp.getNumber()));            //writing index
//                pos = temp.getPosition();
//                for (i = 0; i < pos.length; i++) {
//                    bw.write("\t" + String.valueOf(pos[i]));           //writing position
//                }
//                bw.write("\t" + String.valueOf(temp.getAmountOfEdges()));           //writing number of neighbours
//                temp.firstEdge();
//                while (temp.hasEdge()) {
//                    edge = temp.getEdgeDoNext();
//                    bw.write("\t" + String.valueOf(edge.getUnitConnectedTo(temp).getNumber()));    //writing index of neighbours
//                }
//                bw.newLine();
//            }
//        }
//        catch (IOException ex) {
//            System.out.println("Error. Problems exporting network.");
//        }
//    }

    public float calcModelError() {
        calcNearest(1);
        return dNear_1;
    }

    /**
     * Finds the nearest unit to the given pattern.
     *
     * @param   ed  a constant which multiplies the error signal
     * @param   wd  a constant to subtract from the weight signal
     */
    public void calcNearest(float ed) {
        float temp;
        AbstractGNGCell tempCell;
        dNear_1 = Float.MAX_VALUE;
        dNear_2 = Float.MAX_VALUE;

        firstCell();
        while (hasCell()) {
            tempCell = (AbstractGNGCell) getCurrentCell();
            //------------------------------------------------------------------
            if (tempCell.getAmountOfEdges() == 0) {                 // Delete isolated cells
                deleteCurrentCellDoNext();
            }
            //------------------------------------------------------------------
            else {
            //------------------------------------------------------------------
                tempCell.decreaseError(ed);
            //------------------------------------------------------------------
                
                temp = tempCell.calcDistanceTo(currentInput);
                if (temp < dNear_1) {
                    dNear_2 = dNear_1;              //update distances
                    dNear_1 = temp;
                    near_2 = near_1;
                    near_1 = tempCell;              //update cells
                }
                else {
                    if (temp < dNear_2) {
                        dNear_2 = temp;
                        near_2 = tempCell;
                    }
                }
                nextCell();
            }
        }
    }

    public void step_4_5_6(float eBest, float eNeighbors, float qError, float hold, float wi, float wd) {
        this.addToError(this.dNear_1);                                          //cumulated error -> plot

        if (this.dNear_1 > qError) {
            this.near_1.update(this.dNear_1, eBest, eNeighbors, wi, wd, this.near_2);
                                                                                //4. Add the squared distance between the input signal and the nearest unit in input space to a local counter variable.
                                                                                //5. Move s1 and its direct topological neighbors towards I.
                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
        }
        else {
            this.near_1.update(this.dNear_1*hold, eBest*hold, eNeighbors*hold, wi, wd, this.near_2);
                                                                                //4. Add the squared distance between the input signal and the nearest unit in input space to a local counter variable.
                                                                                //5. Move s1 and its direct topological neighbors towards I.
                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
        }
    }

//    public void trainStep(int it, float eBest, float eNeighbors, int aMax, int lambda, float alfa, float d, float qError, float hold, float superposition, int size) {
    public void trainStep(int it, float eBest, float eNeighbors, int aMax, int lambda, float alfa, float qError, float hold, float superposition, float wi, float wd, int size) {
                                                                                //1. Generate an input signal I.


                                                                                //  Remove unused cells -> step 7
                                                                                //  Decrease all error variables -> step 9
//        this.calcNearest(d);                                                    //2. Find the nearest unit s1 and the second-nearest unit s2.

//        //......................
//        if (near_1 == near_2) {
//            throw new NullPointerException("Es la misma!!" + String.valueOf(neuralGas.getNumberOfCells()));
//        }
//        //......................

        this.near_1.incrementAge();                                             //3. Increment the age of all edges emanating from s1.

        this.step_4_5_6(eBest, eNeighbors, qError, hold, wi, wd);

//        this.addToError(this.dNear_1);                           //cumulated error -> plot
//
//        //---------------------------------------
//        if (this.dNear_1 > qError) {
//            this.near_1.update(this.dNear_1, eBest, eNeighbors, this.near_2);
//                                                                                //4. Add the squared distance between the input signal and the nearest unit in input space to a local counter variable.
//                                                                                //5. Move s1 and its direct topological neighbors towards I.
//                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
//        }
//        else {
//        //---------------------------------------
//
//            this.near_1.update(this.dNear_1*hold, eBest*hold, eNeighbors*hold, this.near_2);
//                                                                                //4. Add the squared distance between the input signal and the nearest unit in input space to a local counter variable.
//                                                                                //5. Move s1 and its direct topological neighbors towards I.
//                                                                                //6. If s1 and s2 are connected by an edge, set the age of this edge to zero. If such an edge does not exist, create it.
//        }

        this.near_1.deleteOlderConnections(aMax);                               //7. Remove edges with an age larger than a_max.
        //neuralGas.forget(aMax);                                               //  If this results in points having no emanating edges, remove them as well.

        if ((it%lambda == 0) && (this.getNumberOfCells() < size)){
            this.insertUnit(alfa, superposition, qError);                       //8. Insert new unit
        }

//        network.decreaseErrors(d);                                            //9. Decrease all error variables by multiplying them with a constant d.

    }

    public AbstractGNGCell getNearest() {
        return near_1;
    }

    public void reset() {
    }

    protected AbstractGNGCell near_1;
    protected AbstractGNGCell near_2;
    protected float dNear_1;
    protected float dNear_2;
}
