package visualFNNXCascadeCorrelation;

import plugin.AbstractFNNXConfigurationWindow;
import plugin.FNNXConfigurationWindow;

/*
 * ConfigurationWindow.java
 *
 * Created on 16 December 2008, 15:23
 */



/**
 *
 * @author  hsatizab
 */
public class ConfigurationWindow extends AbstractFNNXConfigurationWindow implements FNNXConfigurationWindow {
    
    /** Creates new form ConfigurationWindow */
    public ConfigurationWindow(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldNetwork = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldNeurons = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldDataset = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jComboBoxOAF = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldInputTrainer = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldOutputTrainer = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldTester = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jTextFieldValidator = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldStopIfTesterBelow = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldPlotter = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextFieldSaver = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldDelay = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jButtonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("FNNXCascadeCorrelation");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameters"));
        jPanel2.setLayout(new java.awt.GridLayout(12, 2, 5, 5));

        jLabel5.setText("Network:");
        jPanel2.add(jLabel5);
        jPanel2.add(jTextFieldNetwork);

        jLabel3.setText("Number of Neurons:");
        jPanel2.add(jLabel3);
        jPanel2.add(jTextFieldNeurons);

        jLabel2.setText("Dataset:");
        jPanel2.add(jLabel2);
        jPanel2.add(jTextFieldDataset);

        jLabel6.setText("Output Activation Function:");
        jPanel2.add(jLabel6);

        jComboBoxOAF.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TANH", "SIGM", "LINEAR" }));
        jPanel2.add(jComboBoxOAF);

        jLabel4.setText("Input Trainer:");
        jPanel2.add(jLabel4);
        jPanel2.add(jTextFieldInputTrainer);

        jLabel15.setText("Output Trainer:");
        jPanel2.add(jLabel15);
        jPanel2.add(jTextFieldOutputTrainer);

        jLabel10.setText("Tester:");
        jPanel2.add(jLabel10);
        jPanel2.add(jTextFieldTester);

        jLabel16.setText("Validator:");
        jPanel2.add(jLabel16);
        jPanel2.add(jTextFieldValidator);

        jLabel11.setText("Stop If Tester Below:");
        jPanel2.add(jLabel11);

        jTextFieldStopIfTesterBelow.setText("0.0");
        jPanel2.add(jTextFieldStopIfTesterBelow);

        jLabel12.setText("Plotter:");
        jPanel2.add(jLabel12);
        jPanel2.add(jTextFieldPlotter);

        jLabel13.setText("Saver:");
        jPanel2.add(jLabel13);
        jPanel2.add(jTextFieldSaver);

        jLabel1.setText("Delay:");
        jPanel2.add(jLabel1);

        jTextFieldDelay.setText("0");
        jPanel2.add(jTextFieldDelay);

        getContentPane().add(jPanel2);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Control"));
        jPanel4.setLayout(new java.awt.GridLayout(1, 2, 5, 2));

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });
        jPanel4.add(jButtonOK);

        getContentPane().add(jPanel4);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-401)/2, (screenSize.height-556)/2, 401, 556);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        OKPressed = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        OKPressed = false;
    }//GEN-LAST:event_formComponentShown
    
    public String[] getFields() {
        String[] fields = new String[12];

        fields[0] = jTextFieldNetwork.getText();
        fields[1] = jTextFieldNeurons.getText();
        fields[2] = jTextFieldDataset.getText();
        fields[3] = toQuot(jComboBoxOAF.getSelectedItem().toString());
        fields[4] = jTextFieldInputTrainer.getText();
        fields[5] = jTextFieldOutputTrainer.getText();
        fields[6] = jTextFieldTester.getText();
        fields[7] = jTextFieldValidator.getText();
        fields[8] = jTextFieldStopIfTesterBelow.getText();
        fields[9] = jTextFieldPlotter.getText();
        fields[10] = jTextFieldSaver.getText();
        fields[11] = jTextFieldDelay.getText();

        return fields;
    }

    public void setFields(String[] f) {

        jTextFieldNetwork.setText(f[0]);
        jTextFieldNeurons.setText(f[1]);
        jTextFieldDataset.setText(f[2]);
        jComboBoxOAF.setSelectedItem(fromQuot(f[3]));
        jTextFieldInputTrainer.setText(f[4]);
        jTextFieldOutputTrainer.setText(f[5]);
        jTextFieldTester.setText(f[6]);
        jTextFieldValidator.setText(f[7]);
        jTextFieldStopIfTesterBelow.setText(f[8]);
        jTextFieldPlotter.setText(f[9]);
        jTextFieldSaver.setText(f[10]);
        jTextFieldDelay.setText(f[11]);

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOK;
    private javax.swing.JComboBox jComboBoxOAF;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JTextField jTextFieldDataset;
    private javax.swing.JTextField jTextFieldDelay;
    private javax.swing.JTextField jTextFieldInputTrainer;
    private javax.swing.JTextField jTextFieldNetwork;
    private javax.swing.JTextField jTextFieldNeurons;
    private javax.swing.JTextField jTextFieldOutputTrainer;
    private javax.swing.JTextField jTextFieldPlotter;
    private javax.swing.JTextField jTextFieldSaver;
    private javax.swing.JTextField jTextFieldStopIfTesterBelow;
    private javax.swing.JTextField jTextFieldTester;
    private javax.swing.JTextField jTextFieldValidator;
    // End of variables declaration//GEN-END:variables
    
}
