package visualFNNXDynamicNodeCreation;

import plugin.AbstractFNNXConfigurationWindow;
import plugin.FNNXConfigurationWindow;

/*
 * ConfigurationWindow.java
 *
 * Created on 16 December 2008, 15:23
 */



/**
 *
 * @author  hsatizab
 */
public class ConfigurationWindow extends AbstractFNNXConfigurationWindow implements FNNXConfigurationWindow {
    
    /** Creates new form ConfigurationWindow */
    public ConfigurationWindow(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        jTextFieldNetwork = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldNeurons = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldDataset = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jComboBoxOAF = new javax.swing.JComboBox();
        jLabel13 = new javax.swing.JLabel();
        jTextFieldShortcut = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldInsertEvery = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldTrainer = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldEpochs = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldTester = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldValidator = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldStopIfTesterBelow = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldLogCounter = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldPlotter = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldSaver = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jButtonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("FNNXDynamicNodeCreation");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameters"));
        jPanel2.setLayout(new java.awt.GridLayout(14, 2, 5, 5));

        jLabel9.setText("Network:");
        jPanel2.add(jLabel9);
        jPanel2.add(jTextFieldNetwork);

        jLabel3.setText("Number of Neurons:");
        jPanel2.add(jLabel3);
        jPanel2.add(jTextFieldNeurons);

        jLabel2.setText("Dataset:");
        jPanel2.add(jLabel2);
        jPanel2.add(jTextFieldDataset);

        jLabel6.setText("Output Activation Function:");
        jPanel2.add(jLabel6);

        jComboBoxOAF.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TANH", "SIGM", "LINEAR" }));
        jPanel2.add(jComboBoxOAF);

        jLabel13.setText("Shortcut:");
        jPanel2.add(jLabel13);

        jTextFieldShortcut.setText("false");
        jPanel2.add(jTextFieldShortcut);

        jLabel10.setText("Insert Every:");
        jPanel2.add(jLabel10);
        jPanel2.add(jTextFieldInsertEvery);

        jLabel15.setText("Trainer:");
        jPanel2.add(jLabel15);
        jPanel2.add(jTextFieldTrainer);

        jLabel12.setText("Epochs:");
        jPanel2.add(jLabel12);
        jPanel2.add(jTextFieldEpochs);

        jLabel1.setText("Tester:");
        jPanel2.add(jLabel1);
        jPanel2.add(jTextFieldTester);

        jLabel4.setText("Validator:");
        jPanel2.add(jLabel4);
        jPanel2.add(jTextFieldValidator);

        jLabel5.setText("Stop If Tester Below:");
        jPanel2.add(jLabel5);

        jTextFieldStopIfTesterBelow.setText("0.0");
        jPanel2.add(jTextFieldStopIfTesterBelow);

        jLabel11.setText("Log Counter:");
        jPanel2.add(jLabel11);

        jTextFieldLogCounter.setText("100");
        jPanel2.add(jTextFieldLogCounter);

        jLabel7.setText("Plotter:");
        jPanel2.add(jLabel7);
        jPanel2.add(jTextFieldPlotter);

        jLabel8.setText("Saver:");
        jPanel2.add(jLabel8);
        jPanel2.add(jTextFieldSaver);

        getContentPane().add(jPanel2);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Control"));
        jPanel4.setLayout(new java.awt.GridLayout(1, 2, 5, 2));

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });
        jPanel4.add(jButtonOK);

        getContentPane().add(jPanel4);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-401)/2, (screenSize.height-630)/2, 401, 630);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        OKPressed = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        OKPressed = false;
    }//GEN-LAST:event_formComponentShown
    
    public String[] getFields() {
        String[] fields = new String[14];

        fields[0] = jTextFieldNetwork.getText();
        fields[1] = jTextFieldNeurons.getText();
        fields[2] = jTextFieldDataset.getText();
        fields[3] = toQuot(jComboBoxOAF.getSelectedItem().toString());
        fields[4] = jTextFieldShortcut.getText();
        fields[5] = jTextFieldInsertEvery.getText();
        fields[6] = jTextFieldTrainer.getText();
        fields[7] = jTextFieldEpochs.getText();
        fields[8] = jTextFieldTester.getText();
        fields[9] = jTextFieldValidator.getText();
        fields[10] = jTextFieldStopIfTesterBelow.getText();
        fields[11] = jTextFieldLogCounter.getText();
        fields[12] = jTextFieldPlotter.getText();
        fields[13] = jTextFieldSaver.getText();

        return fields;
    }

    public void setFields(String[] f) {

        jTextFieldNetwork.setText(f[0]);
        jTextFieldNeurons.setText(f[1]);
        jTextFieldDataset.setText(f[2]);
        jComboBoxOAF.setSelectedItem(fromQuot(f[3]));
        jTextFieldShortcut.setText(f[4]);
        jTextFieldInsertEvery.setText(f[5]);
        jTextFieldTrainer.setText(f[6]);
        jTextFieldEpochs.setText(f[7]);
        jTextFieldTester.setText(f[8]);
        jTextFieldValidator.setText(f[9]);
        jTextFieldStopIfTesterBelow.setText(f[10]);
        jTextFieldLogCounter.setText(f[11]);
        jTextFieldPlotter.setText(f[12]);
        jTextFieldSaver.setText(f[13]);

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOK;
    private javax.swing.JComboBox jComboBoxOAF;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JTextField jTextFieldDataset;
    private javax.swing.JTextField jTextFieldEpochs;
    private javax.swing.JTextField jTextFieldInsertEvery;
    private javax.swing.JTextField jTextFieldLogCounter;
    private javax.swing.JTextField jTextFieldNetwork;
    private javax.swing.JTextField jTextFieldNeurons;
    private javax.swing.JTextField jTextFieldPlotter;
    private javax.swing.JTextField jTextFieldSaver;
    private javax.swing.JTextField jTextFieldShortcut;
    private javax.swing.JTextField jTextFieldStopIfTesterBelow;
    private javax.swing.JTextField jTextFieldTester;
    private javax.swing.JTextField jTextFieldTrainer;
    private javax.swing.JTextField jTextFieldValidator;
    // End of variables declaration//GEN-END:variables
    
}
