/*
 * ConfigurationWindow.java
 *
 * Created on 16 December 2008, 15:23
 */

package visualFNNXMLPEnsemble;

import plugin.AbstractFNNXConfigurationWindow;
import plugin.FNNXConfigurationWindow;

/**
 *
 * @author  hsatizab
 */
public class ConfigurationWindow extends AbstractFNNXConfigurationWindow implements FNNXConfigurationWindow {
    
    /** Creates new form ConfigurationWindow */
    public ConfigurationWindow(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldNetworks = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldInputs = new javax.swing.JTextField();
        jComboBoxInput = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldHidden = new javax.swing.JTextField();
        jComboBoxHidden = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldOutputs = new javax.swing.JTextField();
        jComboBoxOutput = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jButtonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("FNNXMLP");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setModal(true);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameters"));
        jPanel1.setLayout(new java.awt.GridLayout(4, 3, 5, 5));

        jLabel1.setText("Networks:");
        jPanel1.add(jLabel1);
        jPanel1.add(jTextFieldNetworks);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jPanel1.add(jSeparator1);

        jLabel2.setText("Input Units:");
        jPanel1.add(jLabel2);
        jPanel1.add(jTextFieldInputs);

        jComboBoxInput.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "LINEAR" }));
        jPanel1.add(jComboBoxInput);

        jLabel3.setText("Hidden Units:");
        jPanel1.add(jLabel3);
        jPanel1.add(jTextFieldHidden);

        jComboBoxHidden.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TANH", "SIGM", "LINEAR" }));
        jPanel1.add(jComboBoxHidden);

        jLabel4.setText("Output Units:");
        jPanel1.add(jLabel4);
        jPanel1.add(jTextFieldOutputs);

        jComboBoxOutput.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TANH", "SIGM", "LINEAR" }));
        jPanel1.add(jComboBoxOutput);

        getContentPane().add(jPanel1);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Control"));
        jPanel4.setLayout(new java.awt.GridLayout(1, 1));

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });
        jPanel4.add(jButtonOK);

        getContentPane().add(jPanel4);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-360)/2, (screenSize.height-242)/2, 360, 242);
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        OKPressed = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        OKPressed = false;
    }//GEN-LAST:event_formComponentShown
    
    public String[] getFields() {
        String[] fields = new String[6];

        fields[0] = jTextFieldNetworks.getText();
        fields[1] = jTextFieldInputs.getText();
        fields[2] = jTextFieldHidden.getText();
        fields[3] = toQuot(jComboBoxHidden.getSelectedItem().toString());
        fields[4] = jTextFieldOutputs.getText();
        fields[5] = toQuot(jComboBoxOutput.getSelectedItem().toString());

        return fields;
    }

    public void setFields(String[] f) {

        jTextFieldNetworks.setText(f[0]);
        jTextFieldInputs.setText(f[1]);
        jTextFieldHidden.setText(f[2]);
        jComboBoxHidden.setSelectedItem(fromQuot(f[3]));
        jTextFieldOutputs.setText(f[4]);
        jComboBoxOutput.setSelectedItem(fromQuot(f[5]));
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOK;
    private javax.swing.JComboBox jComboBoxHidden;
    private javax.swing.JComboBox jComboBoxInput;
    private javax.swing.JComboBox jComboBoxOutput;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField jTextFieldHidden;
    private javax.swing.JTextField jTextFieldInputs;
    private javax.swing.JTextField jTextFieldNetworks;
    private javax.swing.JTextField jTextFieldOutputs;
    // End of variables declaration//GEN-END:variables
    
}
