/*
 * ExponentialActivationFunction.java
 *
 * Created on 18. septembre 2006, 15:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package functions;

//import scripting.Names;

import model.distributedRepresentation.AbstractActivationFunction;



/**
 *
 * @author Hector
 */
public class ExponentialActivationFunction extends AbstractActivationFunction {
    
    /**
     * Creates a new instance of ExponentialActivationFunction
     */
    public ExponentialActivationFunction() {
    }
    
    /**
     * Returns a copy of the object.
     */
    public ExponentialActivationFunction clone() {
        return (ExponentialActivationFunction) super.clone();
    }
    
    /**
     * Applies the activation function and returns the resulting value.
     *
     * @param   in  input value
     * @return  the resulting value after appplying the activation function
     */
    public float apply(float in) {
        return (float)Math.exp(in);
    }
    
    /**
     * Calculates the first derivative and returns the resulting value
     *
     * @param   out  output value to calculate the first derivative
     * @return  the resulting value
     */
    public float firstDeriv(float out) {
        return out + (float)0.01;             //Fahlman's trick
    }
}
