/*
 * HyperbolicTangentActivationFunction.java
 *
 * Created on 18. septembre 2006, 15:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package functions;

//import scripting.Names;

import model.distributedRepresentation.AbstractActivationFunction;



/**
 *
 * @author Hector
 */
public class HyperbolicTangentActivationFunction extends AbstractActivationFunction {
    
    /**
     * Creates a new instance of HyperbolicTangentActivationFunction
     */
    public HyperbolicTangentActivationFunction() {
    }
    
    /**
     * Returns a copy of the object.
     */
    public HyperbolicTangentActivationFunction clone() {
        return (HyperbolicTangentActivationFunction) super.clone();
    }
    
    /**
     * Applies the activation function and returns the resulting value.
     *
     * @param   in  input value
     * @return  the resulting value after appplying the activation function
     */
    public float apply(float in) {
//        float temp = (float)Math.exp(in);
//        float temp_ = 1 / temp;
//
//        return (temp - temp_) / (temp + temp_);

        if (in > 300) {
            return 1;
        }
        else if (in < -300) {
            return -1;
        }
        else {
            double temp = Math.exp(2 * in);
            return (float)((temp - 1) / (temp + 1));
        }

    }
    
    /**
     * Calculates the first derivative and returns the resulting value
     *
     * @param   out  output value to calculate the first derivative
     * @return  the resulting value
     */
    public float firstDeriv(float out) {
        return (1 - (out * out)) + (float)0.01;             //Fahlman's trick
//        return (1 - (out * out));
    }
}
