/*
 * SigmoidActivationFunction.java
 *
 * Created on 20. juin 2006, 21:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package functions;


import model.distributedRepresentation.AbstractActivationFunction;



/**
 *
 * @author Hector
 */
public class SigmoidalActivationFunction extends AbstractActivationFunction {
    
    /**
     * Creates a new instance of SigmoidActivationFunction
     */
    public SigmoidalActivationFunction() {
    }
    
    /**
     * Returns a copy of the object.
     */
    public SigmoidalActivationFunction clone() {
        return (SigmoidalActivationFunction) super.clone();
    }
    
    /**
     * Applies the activation function and returns the resulting value.
     *
     * @param   in  input value
     * @return  the resulting value after appplying the activation function
     */
    public float apply(float in) {
        return (1 / (1 + (float)Math.exp(-in)));
    }
    
    /**
     * Calculates the first derivative and returns the resulting value
     *
     * @param   out  output value to calculate the first derivative
     * @return  the resulting value
     */
    public final float firstDeriv(float out) {
        return (out * (1 - out)) + (float)0.01;             //Fahlman's trick
//        return (out * (1 - out));
    }
}
