/*
 * AbstractPerceptronLayer.java
 *
 * Created on 24 de septiembre de 2007, 14:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package layers;

//import dataModules.MyLinkedList;
import model.distributedRepresentation.AbstractPerceptronBaseLayer;
import neurons.AbstractPerceptron;
import scripting.Names;

/**
 *
 * @author Hector
 */
public class AbstractPerceptronLayer extends AbstractPerceptronBaseLayer implements Cloneable {
    
    /**
     * Returns a copy of the object.
     */
    public AbstractPerceptronLayer clone() {
        AbstractPerceptronLayer tempc = null;
        tempc = (AbstractPerceptronLayer) super.clone();
        return tempc;
    }
    
    /**
     * Calculates the relevance of every unit in the layer.
     *
     * @param   m   the relevance metric to be used
     */
    public void calcRelevance(Names.relevanceMethod m) {
        this.head();

        switch (m) {
            case GARSON:
            case OVERALL_CONNECTIONS:
            case ANNIGMA:
                while (this.hasNode()) {
                    ((AbstractPerceptron)this.getUnitDoNext()).calcRelevance(m);
                }
                break;
                
            default:
                while (this.hasNode()) {
                    ((AbstractPerceptron)this.getUnitDoNext()).calcRelevance(Names.relevanceMethod.OTHER);
                }
                break;
        }
    }
    
    /**
     * Returns the relevance of each unit inthe layer.
     *
     * @return  an array containing the relevance of every input inthe layer
     */
    public float[] getRelevance() {
        float[] rel = new float[this.size()-1];          //Excluding Bias unit
        int i = 0;
        this.head();
        
        while (this.hasNode() && (i < rel.length)) {
            rel[i] = ((AbstractPerceptron)this.getUnitDoNext()).getRelevance();
            i++;
        }
        return rel;
    }
    
}
