/*
 * HiddenLayer.java
 *
 * Created on 1. mai 2006, 16:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package layers;

import model.distributedRepresentation.AbstractActivationFunction;
import neurons.BiasUnit;
import neurons.HiddenUnit;
//import tools.NeuronFactory;

/**
 *
 * @author hsatiza
 */
public class HiddenLayer extends AbstractPerceptronLayer {
    
    /**
     * Creates a new instance of HiddenLayer.
     */
    public HiddenLayer() {
    }

    public HiddenLayer(HiddenUnit n) {
        this.append(n);
    }

    /**
     * Creates a new instance of HiddenLayer.
     *
     * @param   n   the number of units in the layer
     * @param   af  the activation function of the units in the layer
     */
    public HiddenLayer(int n, AbstractActivationFunction af) {
        
        int i;
        for(i = 0; i < n; i++){
            this.append(new HiddenUnit(af));
        }
        this.append(new BiasUnit());
    }
    
    /**
     * Returns a copy of the object.
     */
    public HiddenLayer clone() {
        return (HiddenLayer) super.clone();
    }
    
}
