/*
 * InputLayer.java
 *
 * Created on 1. mai 2006, 16:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package layers;

//import dataOld.OnePattern;
//import netModules.Neurons.AbstractPerceptron;
import neurons.BiasUnit;
import neurons.InputUnit;

/**
 *
 * @author hsatiza
 */
public class InputLayer extends AbstractPerceptronLayer {
    
    /**
     * Creates a new instance of InputLayer.
     */
    public InputLayer() {
    }
    
    /**
     * Creates a new instance of InputLayer.
     *
     * @param   n   the number of units in the layer
     */
    public InputLayer(int n) {
        for (int i = 0; i < n; i++) {
            this.append(new InputUnit());
        }
        this.append(new BiasUnit());
    }
    
    /**
     * Returns a copy of the object.
     */
    public InputLayer clone() {
        return (InputLayer) super.clone();
    }
    
    /**
     * Does nothing.
     */
    public void calcDelta() {               //do nothing
    }                                       //there is no delta calculation for the input layer
    
    /**
     * Does nothing.
     */
    public void updateWeightsDeltaRuleOnline(double eta, double mu, double weightDecay) {   //do nothing
    }                                                                                       //there is no backwards connections to change

    /**
     * Does nothing.
     */
    public void updateWeightsDeltaRuleBatch(double eta, double mu, double weightDecay) {    //do nothing
    }                                                                                       //there is no backwards connections to change

    /**
     * Does nothing.
     */
    public void updateWeightsQuickprop(double eta, double mu) {     //do nothing
                                                                    //there is no backwards connections to change
    }

    public void setInput(float[] obs) {
        int s;

        if (obs.length < (this.size() - 1)) {     //there is one bias unit
            s = obs.length;
        }
        else {
            s = this.size() - 1;
        }

        this.head();
        for (int i = 0; i < s; i++) {
            ((InputUnit)this.getUnitDoNext()).setInputData(obs[i]);
        }
    }
    
//    public void setInput(int i, float val) {
//        int s;
//
//        if (i >= (this.size()-1)) {     //there is one bias unit
//            return;
//        }
//
//        ((InputUnit)this.getAt(i)).setInputData(val);
//
//    }
}
