/*
 * LayerList.java
 *
 * Created on 8. mai 2006, 15:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package networks;

import data.MyLinkedList;
import java.io.Serializable;
import model.distributedRepresentation.AbstractActivationFunction;
import layers.*;

/**
 *
 * @author hsatiza
 */
public class LayerList extends MyLinkedList implements Cloneable, Serializable {
    
    /** Creates a new instance of LayerList */
    public LayerList() {
    }

    public LayerList clone() {
        LayerList tempc = new LayerList();
        
        this.head();
        while (this.hasNode()) {
            tempc.append(((AbstractPerceptronLayer)this.getDoNext()).clone());
        }
        return tempc;
    }
    
    public OutputLayer getOutputLayer() {
        return (OutputLayer) this.getLast();
    }

    public InputLayer getInputLayer() {
        return (InputLayer) this.getFirst();
    }

    public void insertHidden(int n, AbstractActivationFunction af) {
        this.tail();
        this.insert(new HiddenLayer(n, af));
    }

    public void insertHidden(HiddenLayer h) {
        this.tail();
        this.insert(h);
    }
    
    public void addInput(int n) {
        this.append(new InputLayer(n));
    }

    public void addInput(InputLayer iL) {
        this.append(iL);
    }

    public void addOutput(int n, AbstractActivationFunction af) {
        this.append(new OutputLayer(n, af));
    }

}

