/*
 * FloatingUnit.java
 *
 * Created on 1. mai 2006, 15:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package neurons;

import model.distributedRepresentation.AbstractActivationFunction;
import model.distributedRepresentation.AbstractOutputFunction;
import functions.HyperbolicTangentActivationFunction;
import functions.LinearOutputFunction;
import model.distributedRepresentation.Connector;

/**
 *
 * @author Hector
 */
public class FloatingUnit extends AbstractPerceptron {
    
    /**
     * Creates a new instance of FloatingUnit
     *
     * @param   i   the index of the unit
     */
    public FloatingUnit(int i) {
        number = i;
        activationFunction = new HyperbolicTangentActivationFunction();
        outputFunction = new LinearOutputFunction();
        receiveConnections = true;
    }

    /**
     * Returns a copy of the unit.
     */
    public FloatingUnit clone() {
        FloatingUnit temp = (FloatingUnit) super.clone();
        temp.activationFunction = (AbstractActivationFunction) this.activationFunction.clone();
        temp.outputFunction = (AbstractOutputFunction) this.outputFunction.clone();
        return temp;
    }

    public void calcDelta(float errorDev) {
        delta = d_output * errorDev;
//        if (Float.compare(delta, Float.NaN) == 0) {
//            System.err.print("d_output: ");
//            System.err.print(d_output);
//            System.err.print(" - errorDev: ");
//            System.err.print(errorDev);
//            System.err.println();
//        }
    }
    
    public void updateWeightsDeltaRuleOnline(float eta, float mu, float wd) {
        //Do nothing. Floating units only modify input connections (cascade correlation)
    }

    public void updateWeightsQuickprop(float eta, float mu) {
        //Do nothing. Floating units only modify input connections (cascade correlation)
    }

    public void disconnectBackward() {
        backwardLinks.head();
        while (backwardLinks.hasNode()) {
            ((Connector)backwardLinks.getDoNext()).getRefNeuron().disconnectForwardFrom(this);
        }
    }
}
