/*
 * HiddenUnit.java
 *
 * Created on 1. mai 2006, 11:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package neurons;

import model.distributedRepresentation.AbstractActivationFunction;
import model.distributedRepresentation.AbstractOutputFunction;
import functions.LinearOutputFunction;

/**
 *
 * @author Hector
 */
public class HiddenUnit extends AbstractPerceptron {
    
    /**
     * Creates a new instance of HiddenUnit.
     *
     * @param   af  the activation function of the unit
     */
    public HiddenUnit(AbstractActivationFunction af) {
        activationFunction = af;
        outputFunction = new LinearOutputFunction();
        receiveConnections = true;
    }
    
    /**
     * Returns a copy of the unit.
     */
    public HiddenUnit clone() {
        HiddenUnit temp = (HiddenUnit) super.clone();
        temp.activationFunction = (AbstractActivationFunction) this.activationFunction.clone();
        temp.outputFunction = (AbstractOutputFunction) this.outputFunction.clone();
        return temp;
    }
}
