/*
 * InputUnit.java
 *
 * Created on 1. mai 2006, 11:14
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package neurons;

/**
 *
 * @author Hector
 */
public class InputUnit extends AbstractPerceptron {
    
    /**
     * Creates a new instance of InputUnit.
     */
    public InputUnit() {
        receiveConnections = false;
    }
    
    /**
     * Returns a copy of the unit.
     */
    public InputUnit clone() {
        InputUnit temp = (InputUnit) super.clone();
        temp.inputData = 0;
        return temp;
    }
    
    public void setInputData(float in) {
        inputData = in;
    }

    /**
     * Calculates the output of the unit.
     */
    public void calcOutput() {
        if (use) {
            output = inputData;
        }
        else {
            output = 0;
        }
    }

    /**
     * Does nothing.
     */
    public void calcDelta() {                   //do nothing
    }                                           //there are no delta calculation for the input units

    /**
     * Does nothing.
     */
    public void updateWeightsDeltaRuleOnline(double eta, double mu, double wd) {    //do nothing
    }                                                                               //there are no backward connections to change

    /**
     * Does nothing.
     */
    public void updateWeightsDeltaRuleBatch(double eta, double mu, double wd) {    //do nothing
    }                                                                               //there are no backward connections to change

    /**
     * Does nothing.
     */
    public void updateWeightsQuickprop(double eta, double mu) {                     //do nothing
    }                                                                               //there are no backward connections to change

    /**
     * Does nothing.
     */
    public void addToWeightIncrements() {                                           //do nothing
    }                                                                               //there are no backward connections to change

    /**
     * Calculates the sensitivity with respect to a given unit.
     *
     * @param   n   the sensitivity is calculated with respect to this unit
     * @return  1, if the given unit is this unit, 0 otherwise
     */
    public double calcSensitivity(AbstractPerceptron n) {
        if (this.equals(n)) {
            return 1.0;
        }
        else {
            return 0.0;
        }
    }
    
    private float inputData;
}
