/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXPlotter;

import java.util.Hashtable;
import javax.swing.JFrame;
import plugin.*;
import visualFNNXPlotter.PlotFrame;
import scripting.InterThreadMonitor;
import scripting.Names;
import scripting.PlotMode;
import visualFNNXPlotter.ConfigurationWindow;

/**
 *
 * @author hector
 */
public class FNNXPlotter extends AbstractFNNXParallelObserver implements FNNXObject {

    public FNNXPlotter (Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;

        parameterNames = new String[0];
        parameterTypes = new Class[0];
        isParameterMandatory = new boolean[0];
        parameters = new Object[0];
    }

    public FNNXPlotter (JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[0];
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            plotWindow = new PlotFrame(0);
            plotWindow.setSize(400, 300);
            plotWindow.setVisible(false);
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public void run() {
        int par;
        System.out.println("Plotter initialized.");
        while (observerMonitor.isRunning()) {
            observerResults = observerMonitor.getResults();
            par = observerResults.getParameter();

            switch (observerResults.getCommand()) {
                case doNothing:
                    break;

                case init:
//                    super.initialize(par);
//                    observerResults = new InterThreadBuffer(par);
                    if (plotWindow == null) {
                        plotWindow = new PlotFrame(par);
                        plotWindow.setSize(400, 300);
                        plotWindow.setVisible(true);
                    }
                    else {
                        plotWindow.changeConfiguration(par);
                    }
                    break;

                case lastData:
//                    plotWindow.setDeterminate();
//                    plotWindow.setIterationsEnd(((Integer)observerResults.getParameter()).intValue());
                    plotWindow.setIterationsEnd(par);
                case newData:
//                    plotWindow.addPoints(observerResults.getData(), ((Integer)observerResults.getParameter()).intValue());
                    plotWindow.addPoints(observerResults.getData(), par);
//                    plotWindow.repaint();
                    break;

                case setMaxIterations:
//                    plotWindow.setIterationsEnd(((Integer)observerResults.getParameter()).intValue());
                    plotWindow.setIterationsEnd(par);
                    break;

                case setPlotterMode:
                    plotWindow.setMode(new PlotMode(Names.plotModes.valueOf(observerMonitor.getMessage()), par));
                    if (!plotWindow.isVisible()) {
                        plotWindow.setVisible(true);
                    }
                    break;

                case clearPlot:
                    plotWindow.clearPanel();
                    break;

                default:
                    break;
            }
            if (!monitor.isRunning()) {
                observerMonitor.notRunning();
            }
        }
        System.out.println("Plotter finished.");
    }

//    public void initialize(int lines) {
//        super.initialize(lines);
//        observerResults = new InterThreadBuffer(lines);
//        if (plotWindow == null) {
//            plotWindow = new PlotFrame(lines);
//            plotWindow.setSize(400, 300);
//            plotWindow.setVisible(true);
//        }
//        else {
//            plotWindow.changeConfiguration(lines);
//        }
//    }

    transient private PlotFrame plotWindow;
}
