/*
 * PlotFrame.java
 *
 * Created on 16. avril 2007, 14:39
 */

package visualFNNXPlotter;
        
import java.util.LinkedList;
import javax.swing.JPanel;
import scripting.Names;
import scripting.PlotMode;


/**
 *
 * @author  Hector
 */
public class PlotFrame extends javax.swing.JFrame {
    
    /** Creates new form PlotFrame */
    public PlotFrame(int n) {
        series = new LinkedList[n];
        for (int i = 0; i < n; i++) {
            series[i] = new LinkedList<Float>();
        }
//        readingData = false;
//        modifyingData = false;
        lock = false;

        hFact = 10;
        vFact = 50;
        hMin = 50;
        vMin = 10;
        
        vMult = 1;
        
        mode = new PlotMode(scripting.Names.plotModes.none, 0);
        
        initComponents();
    }

//    public synchronized void changeConfiguration(int n) {
    public void changeConfiguration(int n) {
//        setModifying(true);
        this.lock("changeConfiguration... " + String.valueOf(n));
        mode = new PlotMode(Names.plotModes.none, 0);
        series = new LinkedList[n];
        for (int i = 0; i < n; i++) {
            series[i] = new LinkedList<Float>();
        }
//        setModifying(false);
        this.unlock("changeConfiguration... " + String.valueOf(n));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelControl = new javax.swing.JPanel();
        jButtonZoomIn = new javax.swing.JButton();
        jButtonZoomOut = new javax.swing.JButton();
        jButtonClear = new javax.swing.JButton();
        jProgressBar = new FNNXPlotterProgressBar(this);
        jPanelPlot = new PlotPanel(this);

        setTitle("Plot");
        getContentPane().setLayout(new java.awt.BorderLayout(5, 5));

        jPanelControl.setLayout(new java.awt.GridBagLayout());

        jButtonZoomIn.setText("ZoomIn");
        jButtonZoomIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomInActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 5;
        jPanelControl.add(jButtonZoomIn, gridBagConstraints);

        jButtonZoomOut.setText("ZoomOut");
        jButtonZoomOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomOutActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 5;
        jPanelControl.add(jButtonZoomOut, gridBagConstraints);

        jButtonClear.setText("Clear");
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClearActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 5;
        jPanelControl.add(jButtonClear, gridBagConstraints);

        jProgressBar.setString("0");
        jProgressBar.setStringPainted(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelControl.add(jProgressBar, gridBagConstraints);

        getContentPane().add(jPanelControl, java.awt.BorderLayout.PAGE_END);

        jPanelPlot.setBackground(new java.awt.Color(51, 51, 51));
        jPanelPlot.setLayout(new java.awt.BorderLayout());
        getContentPane().add(jPanelPlot, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents


    private void jButtonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClearActionPerformed
        this.clearPanel();
//        System.out.println("Modifying: " + String.valueOf(modifyingData));
//        System.out.println("Reading: " + String.valueOf(readingData));
//        System.out.println("Bar indeterminate: " + String.valueOf(jProgressBar.isIndeterminate()));
    }//GEN-LAST:event_jButtonClearActionPerformed

//    public synchronized void clearPanel() {
    public void clearPanel() {
//        setModifying(true);
        this.lock("clearPanel");
        for (int i = 0; i < series.length; i++) {
            series[i].clear();
        }
        hFact = 10;
        vFact = 50;
        vMult = 1;
        hMin = 60;
        vMin = 10;
//        setModifying(false);
        this.unlock("clearPanel");
        
//        jPanelPlot.update(jPanelPlot.getGraphics());
        jPanelPlot.repaint();
    }
    
//    public synchronized JPanel getPlotPanel() {
    public JPanel getPlotPanel() {
        return jPanelPlot;
    }
    
    /**
     * Increases the vertical factor of the plot.
     */
    private void jButtonZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomOutActionPerformed
        this.lock("zoomOut");
        if (mode.getMode() == Names.plotModes.YvsT_single) {
            if (vFact < 5) {
                this.unlock("zoomOut");
                return;
            }
            else {
                vFact = vFact / 1.5;
            }
        }
        else {
            if (mode.getMode() == Names.plotModes.bars) {
                if (vMult <= 1) {
                    this.unlock("zoomOut");
                    return;
                }
                else {
                    vMult = vMult / 2;
                }
            }
        }
        this.unlock("zoomOut");
        jPanelPlot.repaint();
    }//GEN-LAST:event_jButtonZoomOutActionPerformed

    /**
     * Decreases the vertical factor of the plot.
     */
    private void jButtonZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomInActionPerformed
        this.lock("zoomIn");
        if (mode.getMode() == Names.plotModes.YvsT_single) {
            if (vFact >= 2000) {
                this.unlock("zoomIn");
                return;
            }
            else {
                vFact = vFact * 1.5;
            }
        }
        else {
            if (mode.getMode() == Names.plotModes.bars) {
                if (vMult > 16) {
                    this.unlock("zoomIn");
                    return;
                }
                else {
                    vMult = vMult * 2;
                }
            }
        }
        this.unlock("zoomIn");
        jPanelPlot.repaint();
    }//GEN-LAST:event_jButtonZoomInActionPerformed
    
//    public void newPoints(float r, int i) {
//        if (series.length != 1) {
//            return;
//        }
//        else {
//            float[] temp = new float[1];
//            temp[0] = r;
//            this.addPoints(temp, i);
//        }
//    }
    
//    public synchronized void addPoints(float[] r, int it) {
    public void addPoints(float[] r, int it) {
//        this.setModifying(true);
        this.lock("addPoints ..." + String.valueOf(r.length));
        int i;

        if (series.length != r.length) {
//            this.setModifying(false);
            System.err.println("ouch (length)... " + String.valueOf(series.length) + " - " + String.valueOf(r.length));
            this.unlock("addPoints ..." + String.valueOf(r.length));
            return;
        }
//--------------------
        Float test;
        if (mode.getMode() == Names.plotModes.bars) {
            for (i = 0; i < series.length; i++) {
                series[i].clear();
            }
        }

        for (i = 0; i < series.length; i++) {
            test = new Float(r[i]);
            //series[i].add(new Float(r[i]));
            series[i].add(test);
        }

        if (hFact > 1) {
            if ((series[0].size() * hFact) > (jPanelPlot.getWidth() - (2*hMin))) {
                hFact = (double) (jPanelPlot.getWidth() - (2*hMin)) / (2 * series[0].size());
                if (hFact < 1) {
                    hFact = 1;
                }
            }
        }

        if (mode.getMode() == Names.plotModes.YvsT_single) {
            while ((series[0].size() * hFact) > (jPanelPlot.getWidth() - (2*hMin))) {
                for (i = 0; i < series.length; i++) {
                    series[i].removeFirst();
                }
            }
        }

//        this.setModifying(false);
        
        this.unlock("addPoints ..." + String.valueOf(r.length));

        jProgressBar.setValue(it);
        jProgressBar.setString(String.valueOf(it));
        this.repaint();
        
    }
    
    public synchronized void lock(String m) {

        while (lock) {
//            System.err.println(m + " waiting ...");
            try {
                wait();
            }
            catch (InterruptedException ex) {
            }
        }
        
        this.setIgnoreRepaint(true);
        jPanelPlot.setIgnoreRepaint(true);
        jProgressBar.setIgnoreRepaint(true);
        lock = true;
        
//        System.err.println("locked by: " + m);

        notify();
    }

    public synchronized void unlock(String m) {
        lock = false;

//        System.err.println("unlocked by: " + m);
        this.setIgnoreRepaint(false);
        jPanelPlot.setIgnoreRepaint(false);
        jProgressBar.setIgnoreRepaint(false);

        notify();
    }

//    public synchronized LinkedList<Float>[] getData() {
    public LinkedList<Float>[] getData() {
        return series;
    }
    
    public double getHFact() {
        return hFact;
    }

    public double getVFact() {
        return vFact;
    }
        
    public double getVMult() {
        return vMult;
    }
    
    public int getHMin() {
        return hMin;
    }

    public int getVMin() {
        return vMin;
    }
    
//    public synchronized void setIterationsEnd(int e) {
    public void setIterationsEnd(int e) {
        this.lock("setIterationsEnd=" + String.valueOf(e));

        if (e < 0) {
            jProgressBar.setIndeterminate(true);
            jProgressBar.setString("");
        }
        else {
            jProgressBar.setIndeterminate(false);
            jProgressBar.setMaximum(e);
        }
        this.unlock("setIterationsEnd=" + String.valueOf(e));

    }

//    public synchronized void setMode(PlotMode m) {
    public void setMode(PlotMode m) {
        this.lock("setMode... " + m.toString());
        mode = m;
        this.unlock("setMode... " + m.toString());
    }
    
//    public synchronized Names.plotModes getMode() {
    public Names.plotModes getMode() {
        return mode.getMode();
    }
    
//    public synchronized int getLinesPerChannel() {
    public int getLinesPerChannel() {
        return mode.getLinesPerChannel();
    }
    
    public int getNumberOfTraces() {
//    public synchronized int getNumberOfTraces() {
        return series.length;
    }

    private LinkedList<Float>[] series;
    
    private boolean lock;
    
    private double hFact;
    private double vFact;
    private double vMult;
    private int hMin;
    private int vMin;
    
    private PlotMode mode;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonClear;
    private javax.swing.JButton jButtonZoomIn;
    private javax.swing.JButton jButtonZoomOut;
    private javax.swing.JPanel jPanelControl;
    private javax.swing.JPanel jPanelPlot;
    private javax.swing.JProgressBar jProgressBar;
    // End of variables declaration//GEN-END:variables

    
}
