/*
 * PlotPanel.java
 *
 * Created on 16. avril 2007, 16:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package visualFNNXPlotter;

import java.awt.Color;
import java.awt.Graphics;
import java.util.LinkedList;
import java.util.ListIterator;
import javax.swing.JPanel;

/**
 *
 * @author Hector
 */
public class PlotPanel extends JPanel {
    
    /** Creates a new instance of PlotPanel */
    public PlotPanel(PlotFrame pf) {
        frame = pf;
        zero = 0;
        ignorePaint = false;
    }
    
    /**
     * Paints the panel.
     *
     */
    public void paint(Graphics g) {
        if (ignorePaint) {
            return;
        }
        frame.lock("paint - panel");

//        Graphics2D g2D = (Graphics2D)g.create();
//        int interval;
        Float last, act;
        int i, j;
        
        if (isOpaque()) {                               //paint background
            g.setColor(getBackground());
            g.fillRect(0, 0, getWidth(), getHeight());
        }
        
//        this.drawAxes(g2D);
//----------------------------------------------------------------------------------------------------------
        LinkedList<Float>[] data;
        ListIterator pointIt;

//        frame.setReading(true);
        data = frame.getData();
        
        if (data.length > 0) {
            //---------------------------
            hMin = frame.getHMin();
            hFact = frame.getHFact();
            vMin = frame.getVMin();
            vFact = frame.getVFact();
            int linesPerChannel = frame.getLinesPerChannel();
            //---------------------------
            
            switch (frame.getMode()) {
                case YvsT_single:
                    zero = 0;
                    interval = this.getHeight() - (2*vMin);
                    this.drawAxes(g);
                    for (i = 0; i < data.length; i++) {
                        pointIt = data[i].listIterator(0);

                        g.setColor(Color.WHITE);
                        if(data[i].size() > 0) {
                            last = (Float) pointIt.next();

                            for (j = 0; pointIt.hasNext(); j++) {
                                act = (Float) pointIt.next();
                                g.drawLine(H(j), V(last), H(j+1), V(act));
                                last = act;
                            }
                        }
                    }
                    break;
                    
                case YvsT_multi:
                    interval = (int)((this.getHeight() - (2*vMin)) / (data.length/linesPerChannel));
                    zero = (int)(interval/2);
                    hFact = (double) (this.getWidth() - (2*hMin)) / data[0].size();
                    vFact = 0.45 * interval;

                    for (i = 0; i < data.length; i++){
                        this.drawAxes(g);

                        if (data[i].size() > 0) {
                            pointIt = data[i].listIterator(0);
                            g.setColor(Color.GREEN);
                            last = (Float) pointIt.next();
                            for (j = 0; pointIt.hasNext(); j++) {
                                act = (Float) pointIt.next();
                                g.drawLine(H(j), V(last), H(j+1), V(act));
                                last = act;
                            }
                        }
                        
                        if (linesPerChannel == 2) {
                            i++;
                            if (data[i].size() > 0) {
                                pointIt = data[i].listIterator(0);
                                g.setColor(Color.CYAN);
                                for (j = 0; pointIt.hasNext(); j++) {
                                    act = (Float) pointIt.next();
                                    g.fillOval(H(j)-2, V(act)-2, 5, 5);
                                }
                            }
                        }

                        vMin = vMin + interval;
                    }
                    zero = 0;
                    break;
                    
                case bars:
                    if (data[0].size() != 0) {
                        interval = (int)((this.getHeight() - (2*vMin)) / data[0].size());
                        hFact = (double) (this.getWidth() - (2*hMin)) / data.length;
                        vFact = interval*frame.getVMult();
                        this.drawAxes(g);

                        for (i = 0; i < data.length; i++) {
                            pointIt = data[i].listIterator(0);

                            g.setColor(Color.BLUE);
                            if(data[i].size() > 0) {
                                for (j = 0; pointIt.hasNext(); j++) {
                                    zero = j*interval;
                                    act = Float.valueOf(Math.abs(((Float) pointIt.next()).floatValue()));
                                    if (act != Float.NaN) {
                                        g.fillRect(H(i), V(act), (int)hFact-1, (int)(act*vFact));
                                    }
                                }
                            }
                        }
                    }
                    else {
                        this.drawAxes(g);
                        System.err.println("ouch (data - bars)!!!");
                    }
                    zero = 0;
                    break;

                default:
                    System.err.println("ouch (mode)!!!");
                    break;
            }
        }
        else {
            System.err.println("ouch (data)!!!");
        }
        
//        frame.setReading(false);
        frame.unlock("paint - panel");
//        g2D.dispose();                                  //clean up
    }

    /**
     * Draws the plot axes.
     */
//    public void drawAxes(Graphics2D g2D) {
    public void drawAxes(Graphics g) {
//        g2D.setColor(Color.ORANGE);
        g.setColor(Color.ORANGE);
        
        g.drawLine(hMin, vMin, hMin, vMin+interval);   //vertical line
        g.drawLine(hMin, V(Float.valueOf(0)), this.getWidth()-hMin, V(Float.valueOf(0)));                     //horizontal line

        int pos;
        pos = (this.getHeight()-vMin) - (int)(0.1*interval);
        g.drawLine(hMin-2, pos, hMin+2, pos);   //horizontal line
        g.drawString(String.format("%2.3f", inverseV(pos)), 1, pos+5);

        pos = (this.getHeight()-vMin) - (int)(0.3*interval);
        g.drawLine(hMin-2, pos, hMin+2, pos);   //horizontal line
        g.drawString(String.format("%2.3f", inverseV(pos)), 1, pos+5);

        pos = (this.getHeight()-vMin) - (int)(0.5*interval);
        g.drawLine(hMin-2, pos, hMin+2, pos);   //horizontal line
        g.drawString(String.format("%2.3f", inverseV(pos)), 1, pos+5);

        pos = (this.getHeight()-vMin) - (int)(0.7*interval);
        g.drawLine(hMin-2, pos, hMin+2, pos);   //horizontal line
        g.drawString(String.format("%2.3f", inverseV(pos)), 1, pos+5);

        pos = (this.getHeight()-vMin) - (int)(0.9*interval);
        g.drawLine(hMin-2, pos, hMin+2, pos);   //horizontal line
        g.drawString(String.format("%2.3f", inverseV(pos)), 1, pos+5);
    }

    /**
     * Transforms a x coordinate into a screen useful position.
     * @param   t   the x axis value to transform.
     * @return  an integer value containing the horizontal coordinate to paint on the window.
     */
    public int H(int t) {
        return (int) (t * hFact) + hMin + 1;
    }

    /**
     * Transforms a Float value (Y coordinate) to a valid vertical position.
     * @param   p   the Float to transform.
     * @return  an integer value containing the vertical coordinate to paint on the window.
     */
    public int V(Float p) {
        return (int) (this.getHeight() - ((p.floatValue() * vFact) + zero + vMin));
    }
    
    /**
     * Transforms an integer value (vertical position) to the float value that represents.
     * @param   i   the integer to transform.
     * @return  a float value represented by the given position.
     */
    public float inverseV(int i) {
        return (float) ((this.getHeight() - (i + zero + vMin)) / vFact);
    }

    public void setIgnoreRepaint(boolean ir) {
        super.setIgnoreRepaint(ir);
        ignorePaint = ir;
    }

    private PlotFrame frame;
    private int zero;
    private int hMin;
    private double hFact;
    private int vMin;
    private double vFact;
    private int interval;

    private boolean ignorePaint;
}

