/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package neurons;

import data.MyFloat;
import model.distributedRepresentation.AbstractPerceptronBase;
import model.distributedRepresentation.Connector;

/**
 *
 * @author hsatizab
 */
public class RBMConnector extends Connector {
    
    public RBMConnector(AbstractPerceptronBase r, MyFloat w, MyFloat lw) {
        weight = w;
        lastWeightIncrement = lw;
        refNeuron = r;
        lastPartialDerivative = new MyFloat(0);
        weightIncrement = 0;
        activationProductReal = 0;
        activationProductFantasy = 0;
    }
    
    public void setActivationProductReal(float ap) {
        activationProductReal = ap;
    }
    
    public void setActivationProductFantasy(float ap) {
        activationProductFantasy = ap;
    }
    
    public float getActivationProductReal() {
        return activationProductReal;
    }
    
    public float getActivationProductFantasy() {
        return activationProductFantasy;
    }
    
    public void addToActivationProductReal(float dap) {
        activationProductReal += dap * refNeuron.getActivation();
    }
    
    public void addToActivationProductFantasy(float dap) {
        activationProductFantasy += dap * refNeuron.getActivation();
    }

    void reset() {
        activationProductReal = 0;
        activationProductFantasy = 0;
        weightIncrement = 0;
        lastPartialDerivative.setValue(0);
    }
    
    private float activationProductReal;
    private float activationProductFantasy;


}
