/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package toolFNNXWeightTester;

import visualFNNXWeightTester.ConfigurationWindow;
import plugin.*;
import java.util.Hashtable;
import javax.swing.JFrame;
import networks.AbstractFNNXFeedForwardNetwork;
import scripting.InterThreadBuffer;
import scripting.InterThreadMonitor;
import scripting.Names;

/**
 *
 * @author hsatizab
 */
public class FNNXWeightTester extends AbstractFNNXFunction implements FNNXObject, FNNXFunction {

    public FNNXWeightTester(Hashtable<String, Object> vars, InterThreadMonitor m) {
        this.setName();
        configurationWindow = null;
        variables = vars;
        monitor = m;
        plotMode = Names.plotModes.YvsT_single;

        parameterNames = new String[3];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";
        parameterNames[2] = "plotter";

        parameterTypes = new Class[3];
        parameterTypes[0] = AbstractFNNXFeedForwardNetwork.class;
        parameterTypes[1] = AbstractFNNXParallelObserver.class;
        parameterTypes[2] = AbstractFNNXParallelObserver.class;

        isParameterMandatory = new boolean[3];
        isParameterMandatory[0] = true;
        isParameterMandatory[1] = false;
        isParameterMandatory[2] = false;

        parameters = new Object[3];
    }

    public FNNXWeightTester(JFrame parent) {
        this.setName();
        configurationWindow = new ConfigurationWindow(parent, true);
        variables = null;

        parameterNames = new String[3];
        parameterNames[0] = "network";
        parameterNames[1] = "saver";
        parameterNames[2] = "plotter";
    }

    public boolean prepare(InterThreadMonitor m) {
        if (configured) {
            return true;
        }
        monitor = m;

        try {
            network = (AbstractFNNXFeedForwardNetwork)parameters[0];
            saver = (AbstractFNNXParallelObserver)parameters[1];
            plotter = (AbstractFNNXParallelObserver)parameters[2];

            res = new float[1];
            results = new InterThreadBuffer(1);
        }
        catch(NullPointerException ne) {
            monitor.appendErrorMessage("Internal error. Null pointer.");
            return false;
        }
        catch(IndexOutOfBoundsException ie) {
            monitor.appendErrorMessage("Internal error. Index out of bounds.");
            return false;
        }
        catch(ClassCastException ce) {
            monitor.appendErrorMessage("Internal error. Class cast.");
            return false;
        }

        configured = true;
        return true;
    }

    public Object eval(InterThreadMonitor m) {
        if (!this.prepare(m)) {
            return null;
        }

        this.initPlotter(-1, 1);
        this.initSaver();

        res[0] = network.getWeightSum();

        if (hasPlotter) {
            results.lastData(res, 1);
            plotter.getMonitor().newResults(results);
        }
        if (hasSaver) {
            results.newData(res, 1);
            saver.getMonitor().newResults(results);
        }

        this.endPlotter();
        this.endSaver();

        return res;
    }

    private AbstractFNNXFeedForwardNetwork network;

}
